if [[ -n "$ARCGISHOME" && -d "$ARCGISHOME" ]]; then
    export AGSSERVER="${ARCGISHOME}/"
    export WINEPATH="$ARCGISHOME/bin/wine"
    export DOTWINE="$ARCGISHOME/framework/runtime/.wine"
    export WINEPREFIX="$DOTWINE"
    export ENGINEJAVA94="$ARCGISHOME/"
    export CLASSPATH="$ARCGISHOME/framework/lib/arcobjects.jar:${CLASSPATH}"
    export ARCGIS_JAVA_HOME="${AGSSERVER}/framework/runtime/jre/"
    export TOMCATBIN=$ARCGISHOME/framework/runtime/tomcat/bin
    export XVFBPATH=$ARCGISHOME/framework/runtime/xvfb/Xvfb
    export FONTCONFIG_PATH=$ARCGISHOME/framework/runtime/xvfb/Xvfb/etc/fonts
    export FONTCONFIG_FILE=$ARCGISHOME/framework/runtime/xvfb/Xvfb/etc/fonts/fonts.conf
    export WINEDEBUG=-all
    export LIBGL_DRIVERS_PATH=$XVFBPATH/lib64/dri
    export HOMEPATH="$HOME"

    #Don't set SDEHOME if already set
    if [ -z "$SDEHOME" ]; then
      SDEHOME="${ARCGISHOME}"; export SDEHOME
      PATH=$SDEHOME/bin:$PATH
      LD_LIBRARY_PATH=$SDEHOME/lib:$LD_LIBRARY_PATH
    fi

    # Source user env script
    . $ARCGISHOME/usr/init_user_param.sh

    arcgis_framework=$ARCGISHOME/framework/runtime/ArcGIS
    scripts_dir=$arcgis_framework/Resources/ArcToolBox/Scripts
    bin_dir=$arcgis_framework/bin

    # copy existing paths for deactivate
    export AGS_ORIG_PATH=$PATH
    export AGS_ORIG_LD_LIBRARY_PATH=$LD_LIBRARY_PATH
 
    export PATH=$XVFBPATH/bin:$WINEPATH/bin:$ARCGIS_JAVA_HOME/bin:$scripts_dir:$bin_dir:$PATH
    export LD_LIBRARY_PATH=$XVFBPATH/lib64:$WINEPATH/lib64:$WINEPATH/lib64/wine:$TOMCATBIN:$LD_LIBRARY_PATH

    # don't preload libjsig.so for standalone app
    unset LD_PRELOAD

    owner=`stat -c "%U" ${ARCGISHOME}`
    asrun=`whoami`
    if [[ $asrun != $owner ]]; then
      echo "ERROR: Conda must be run by the ArcGIS Server install user."
    fi
else
    cat << EOF
ERROR: The ARCGISHOME variable is not set properly or path is not accessible.
Manually set the variable by running the following command:
    export ARCGISHOME=/path/to/arcgis/server
 
Then rerun the script to initialize the environment:
source $CONDA_PREFIX/bin/activate $CONDA_DEFAULT_ENV                                  
EOF
    return 1
fi
