﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIM3DLayerProperties():
    """
      Represents 3D layer properties which contain properties used for 
      3D draw.
    """
    castShadows = True
    isLayerLit = True
    layerFaceCulling = FaceCulling3D.eNone
    maxDistance = 0.0
    maxPreloadDistance = 0.0
    minDistance = 0.0
    minPreloadDistance = 0.0
    preloadTextureCutoffHigh = 0.3
    preloadTextureCutoffLow = 0.6
    textureCutoffHigh = 0.3
    textureCutoffLow = 0.6
    textureDownscalingFactor = 0
    useCompressedTextures = True
    verticalExaggeration = 1.0
    verticalUnit = str()
    depthPriority = 0
    lighting = Lighting3D.OneSideDataNormal
    optimizeMarkerTransparency = False
    useDepthWritingForTransparency = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChart():
    """
      Provides access to members that control chart properties.
    """
    name = str()
    series = []
    generalProperties = 'CIMChartGeneralProperties'
    legend = 'CIMChartLegend'
    axes = []
    mapSelectionHandling = ChartMapSelectionHandling.Highlight
    metaData = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartAxis():
    """
      Provides access to members that control chart axis properties.
    """
    visible = True
    isLogarithmic = False
    title = str()
    showTitle = True
    useAutomaticTitle = True
    valueFormat = str()
    valueNumberFormat = 'CIMNumberFormat'
    dateTimeFormat = str()
    calculateAutomaticMinimum = True
    calculateAutomaticMaximum = True
    minimum = object()
    maximum = object()
    titleText = 'CIMChartTextProperties'
    labelText = 'CIMChartTextProperties'
    axisLineSymbolProperties = 'CIMChartLineSymbolProperties'
    guides = []
    labelCharacterLimit = 11
    navigationScaleFactor = 1.0
    navigationPosition = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartFillSymbolProperties():
    """
      Provides access to members that control properties of the fill
        /// symbol.
    """
    color = 'CIMColor'
    opacity = 0
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartGeneralProperties():
    """
      Provides access to members that control general chart properties.
    """
    title = str()
    showTitle = True
    useAutomaticTitle = True
    subTitle = str()
    showSubTitle = True
    footer = str()
    showFooter = True
    theme = str()
    titleText = 'CIMChartTextProperties'
    subTitleText = 'CIMChartTextProperties'
    footerText = 'CIMChartTextProperties'
    backgroundSymbolProperties = 'CIMChartFillSymbolProperties'
    gridLineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartGuide():
    """
      Define the properties to define a chart guide.
    """
    name = str()
    label = str()
    labelText = 'CIMChartTextProperties'
    labelPosition = ChartPosition.ChartPosition_Top
    valueFrom = 0.0
    valueTo = 0.0
    timeFrom = GetPythonClass('datetime', 'datetime')
    timeTo = GetPythonClass('datetime', 'datetime')
    visible = True
    guideType = ChartGuideType.ChartGuideType_Line
    guideValueType = ChartValueType.ChartValueType_Numeric
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLegend():
    """
      Provides access to members that control chart legend properties.
    """
    visible = True
    title = str()
    showTitle = True
    alignment = ChartLegendAlignment.Right
    valueFormat = str()
    legendText = 'CIMChartTextProperties'
    legendTitle = 'CIMChartTextProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLineSymbolProperties():
    """
      Provides access to members that control properties of the line
        /// symbol.
    """
    visible = True
    width = 2
    style = ChartLineDashStyle.Solid
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLocationDefinition():
    """
      Represents the definition of a location for which data is to be 
      plotted.
    """
    geometry = GetPythonClass('arcpy', 'Geometry')
    symbol = 'CIMSymbolReference'
    label = str()
    enabled = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartMarkerSymbolProperties():
    """
      Provides access to members that control properties of the marker
        /// symbol.
    """
    visible = True
    width = 2
    height = 2
    style = ChartMarkerSymbolStyle.Circle
    color = 'CIMColor'
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartSeries():
    """
      Provides access to members that control chart series properties.
    """
    name = str()
    uniqueName = str()
    fields = []
    orderFields = []
    groupFields = []
    whereClause = str()
    showLabels = False
    horizontalAxis = 0
    verticalAxis = 1
    colorType = ChartColorType.SingleColor
    fieldAggregation = []
    orderFieldsSortTypes = []
    visible = True
    dataLabelText = 'CIMChartTextProperties'
    multiSeries = False
    locations = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileBand():
    """
      Represents a band for a variable to be plotted over time.
    """
    bandID = -1
    symbol = 'CIMSymbolReference'
    label = str()
    locationID = -1
    dimension = str()
    dimensionValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileBands():
    """
      Represents the bands for a variable to be plotted over time.
    """
    variable = str()
    bands = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileDimensionValue():
    """
      Represents a dimension value for a given variable to be plotted 
      over time.
    """
    value = float('nan')
    symbol = 'CIMSymbolReference'
    label = str()
    locationID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileDimensionValues():
    """
      Represents dimension values for a given variable to be plotted 
      over time.
    """
    variable = str()
    dimension = str()
    values = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileVariable():
    """
      Represents a variable to be plotted over time.
    """
    name = str()
    symbol = 'CIMSymbolReference'
    label = str()
    dimension = str()
    dimensionValues = []
    dimensionValuesSymbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTextProperties():
    """
      Represents chart text properties.
    """
    fontFillColor = 'CIMColor'
    fontOutlineColor = 'CIMColor'
    fontFamilyName = str()
    fontItalic = False
    fontSize = 12
    fontWeight = ChartFontWeight.Normal
    textCase = ChartTextCase.Normal
    textUnderline = False
    textStrikethrough = False
    textOverline = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDefinitionFilter():
    """
      Contains filters so that only features satisfying these definitions 
      will be displayed.
    """
    name = str()
    definitionExpression = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMElementStorage():
    """
      Represents a series of graphic elements stored offline.
    """
    elements = []
    """
      Represents a series of graphic elements stored offline.
    """
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEyeDomeLighting():
    """
      Represents eye-dome lighting properties.
    """
    isEnabled = True
    strength = 0.0
    radius = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerElevationSurface():
    """
      Represents a layer elevation surface.
    """
    offsetZ = 0.0
    mapElevationID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerTemplate():
    """
      Represents a layer template.
    """
    uRI = str()
    layerTemplateId = str()
    parameters = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubLayerBase():
    """
      Represents sublayer base class.
    """
    description = str()
    expanded = False
    maxScale = 0
    minScale = 0
    name = str()
    showLegends = True
    subLayerID = str()
    visibility = True
    serviceLayerID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayerDrawing():
    """
      Represents symbol layer drawing properties.
    """
    symbolLayers = []
    useSymbolLayerDrawing = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayerIdentifier():
    """
      Represents symbol layer identifier.
    """
    symbolLayerName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMBaseLayer(CIMDefinition):
    """
      Represents the base layer class.
    """
    attribution = str()
    description = str()
    layerElevation = 'CIMLayerElevationSurface'
    expanded = False
    layer3DProperties = 'CIM3DLayerProperties'
    layerMasks = []
    layerType = MapLayerType.Operational
    maxScale = 0.0
    minScale = 0.0
    showLegends = True
    transparency = 0.0
    visibility = True
    displayCacheType = DisplayCacheType.Permanent
    maxDisplayCacheAge = 5.0
    layerTemplate = 'CIMLayerTemplate'
    popupInfo = 'CIMPopupInfo'
    showPopups = True
    serviceLayerID = -1
    charts = []
    searchable = False
    refreshRate = -1.0
    refreshRateUnit = esriTimeUnits.esriTimeUnitsSeconds
    showMapTips = False
    customProperties = []
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMKMLDataConnection(CIMDataConnection):
    """
      Represents a KML data connection.
    """
    kMLURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartBarSeries(CIMChartSeries):
    """
      Provides access to members that control bar chart series.
    """
    multipleBarType = ChartMultiBarType.SideBySide
    barSize = 90
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    verticalOrientation = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartBoxPlotSeries(CIMChartSeries):
    """
      Provides access to members that control bar chart box plot series.
    """
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    verticalOrientation = True
    showOutliers = False
    showInnerPoints = False
    showMean = False
    standardizeValues = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartCalendarHeatSeries(CIMChartSeries):
    """
      Provides access to members that control CalendarHeat series.
    """
    columnTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    rowTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    nullPolicy = ChartNullPolicy.Null
    noDataColor = 'CIMColor'
    classificationMethod = ClassificationMethod.GeometricalInterval
    breaksCount = 0
    minimumBreak = 0.0
    breaks = []
    breakColors = []
    colorRamp = 'CIMColorRamp'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartDataClockSeries(CIMChartSeries):
    """
      Provides access to members that control DataClock series.
    """
    wedgeTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    ringTimeUnits = esriTimeUnits.esriTimeUnitsUnknown
    trimIncompleteTimeInterval = False
    nullPolicy = ChartNullPolicy.Null
    noDataColor = 'CIMColor'
    classificationMethod = ClassificationMethod.GeometricalInterval
    breaksCount = 0
    minimumBreak = 0.0
    breaks = []
    breakColors = []
    colorRamp = 'CIMColorRamp'
    showWedgeLabel = True
    wedgeLabelText = 'CIMChartTextProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartHistogramSeries(CIMChartSeries):
    """
      Provides access to members that control histogram series.
    """
    binCount = 8
    showMean = False
    showMedian = False
    showStandardDeviation = False
    fillSymbolProperties = 'CIMChartFillSymbolProperties'
    meanLineSymbolProperties = 'CIMChartLineSymbolProperties'
    medianLineSymbolProperties = 'CIMChartLineSymbolProperties'
    standardDeviationLineSymbolProperties = 'CIMChartLineSymbolProperties'
    showComparisonDistribution = False
    dataTransformationType = ChartDataTransformationType.eNone
    distributionLineSymbolProperties = 'CIMChartLineSymbolProperties'
    countField = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartLineSeries(CIMChartSeries):
    """
      Provides access to members that control line series.
    """
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    timeAggregationType = ChartTimeAggregationType.eNone
    timeIntervalUnits = esriTimeUnits.esriTimeUnitsUnknown
    timeIntervalSize = 0.0
    calculateAutomaticTimeInterval = True
    trimIncompleteTimeInterval = False
    nullPolicy = ChartNullPolicy.Null
    verticalOrientation = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartProbabilityPlotSeries(CIMChartSeries):
    """
      Provides access to members that control probability plot series.
    """
    probabilityPlotType = ChartProbabilityPlotType.NormalQQPlot
    dataTransformationType = ChartDataTransformationType.eNone
    showReferenceLine = True
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    referenceLineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartProfileGraphSeries(CIMChartSeries):
    """
      Provides access to members that control profile graph series.
    """
    lineSymbolProperties = 'CIMChartLineSymbolProperties'
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    horizontalUnit = str()
    verticalUnit = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartScatterPlotMatrixSeries(CIMChartSeries):
    """
      Provides access to members that control scatter plot matrix series.
    """
    showHistograms = False
    showTrendLine = False
    showAsRSquared = False
    fieldLabels = []
    scatterMarkerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    histogramFillSymbolProperties = 'CIMChartFillSymbolProperties'
    selectedMiniPlot = -2
    rSquareText = 'CIMChartTextProperties'
    selectionLineSymbolProperties = 'CIMChartLineSymbolProperties'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartScatterSeries(CIMChartSeries):
    """
      Provides access to members that control point chart series.
    """
    markerSymbolProperties = 'CIMChartMarkerSymbolProperties'
    showTrendLine = False
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    trendLineFitType = ChartTrendLineFitType.ChartTrendLineFitType_Linear
    trendOrder = 0
    showTrendEquation = False
    bubbleMinimumSize = 0.0
    bubbleMaximumSize = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartSpectralProfileSeries(CIMChartSeries):
    """
      Represents a chart spectral profile series.
    """
    displayMode = SpectralProfileDisplayMode.MeanLine
    showOutliers = False
    standardizeValues = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartTemporalProfileSeries(CIMChartSeries):
    """
      Represents a temporal profile chart series.
    """
    plotType = ChartTemporalProfilePlotType.Variables
    variables = []
    bands = 'CIMChartTemporalProfileBands'
    dimensionValues = 'CIMChartTemporalProfileDimensionValues'
    standardizeValues = False
    timeIntervalSize = -1.0
    timeIntervalUnits = esriTimeUnits.esriTimeUnitsMonths
    timeAggregationType = ChartTimeAggregationType.eNone
    trimIncompleteTimeInterval = False
    dateTimeFormat = str()
    trendLineSymbolProperties = 'CIMChartLineSymbolProperties'
    showTrendLine = False
    trendLineFitType = ChartTrendLineFitType.ChartTrendLineFitType_Linear
    trendOrder = 1
    showTrendEquation = False
    spatialAggregationType = ChartAggregationType.eNone
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCompositeSubLayer(CIMSubLayerBase):
    """
      Represents a composite sublayer.
    """
    subLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeodatabaseErrorLayer(CIMBaseLayer):
    """
      Represents GDB Error tables as a composite layer and draws the 
      errors.
    """
    pointLayer = str()
    lineLayer = str()
    polygonLayer = str()
    objectTable = str()
    workspaceConnection = 'CIMWorkspaceConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGraphicsLayer(CIMBaseLayer):
    """
      Represents a layer of simple graphic elements.
    """
    elementStorageURI = str()
    referenceScale = 0.0
    barrierWeight = BarrierWeight.High
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupLayer(CIMBaseLayer):
    """
      Represents a group layer which is a simple ordered collection of 
      other layers.
    """
    layers = []
    symbolLayerDrawing = 'CIMSymbolLayerDrawing'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKMLLayer(CIMBaseLayer):
    """
      Represents a KML layer.
    """
    dataConnection = 'CIMKMLDataConnection'
    selectable = False
    selectionColor = 'CIMColor'
    useSelectionColor = False
    labelVisibility = True
    textSymbol = 'CIMTextSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubLayer(CIMSubLayerBase):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTopologyLayer(CIMBaseLayer):
    """
      Represents a topology dataset as a layer and draws its errors,
        /// exceptions, and areas in need of validation.
    """
    allLayers = []
    topologyConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
