﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMAltitudeParams():
    """
      Represents altitude parameters.
    """
    altitudeValue = 0
    mode = AltitudeMode.RelativeToGround
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAnimationScreenGraphic():
    """
      Represents a graphic and list of keyframes indicating properties 
      that can be changed during the animation.
    """
    graphic = 'CIMGraphic'
    alias = str()
    keyframes = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAnimationScreenGraphicKeyframe():
    """
      Properties defining the graphic at a single point in time for the 
      animation.
    """
    trackTime = 0.0
    anchorX = 0.0
    anchorY = 0.0
    transparency = 0.0
    scale = 1.0
    elementWidth = 0.0
    elementHeight = 0.0
    rotation = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBaseComparison():
    """
      Represents a base comparison object.
    """
    joinOperator = JoinOperator.eNone
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBookmark():
    """
      Represents a spatial bookmark.
    """
    name = str()
    thumbnailImagePath = str()
    camera = 'CIMViewCamera'
    location = GetPythonClass('arcpy', 'Extent')
    timeExtent = TimeExtent
    rangeExtent = 'CIMLayerRange'
    description = str()
    videoURI = str()
    videoElapsedTime = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDatumTransform():
    """
      Represents a datum transform.
    """
    forward = True
    geoTransformation = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingElevation():
    """
      Defines the properties needed to specify new Z values when creating 
      or modifying features.
    """
    captureMode = EditingElevationCaptureMode.Off
    constantValue = 0.0
    surfaceID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplateCollectionItem():
    """
      Represents an item that can be stored within an editing template 
      collection.
    """
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMElevationSource():
    """
      Represents an elevation source.
    """
    dataConnection = 'CIMDataConnection'
    verticalUnit = str()
    visibility = True
    name = str()
    metadataURI = str()
    elevationSourceID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMExploratoryAnalysisDefinition():
    """
      Represents an exploratory analysis definition.
    """
    iD = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFieldMapping():
    """
      Represents a field mapping that maps fields from source layer or 
      table to target layer or table.
    """
    sourceURI = str()
    targetURI = str()
    mappingExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroundToGridCorrection():
    """
      Defines the properties needed to perform a COGO ground to grid 
      correction when adding new features.
    """
    enabled = False
    useDirection = True
    useScale = True
    direction = 0.0
    scaleType = GroundToGridScaleType.ConstantFactor
    constantScaleFactor = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMIlluminationProperties():
    """
      Represents illumination properties.
    """
    ambientLight = 75.0
    sunPositionX = -0.61237243569579
    sunPositionY = 0.61237243569579
    sunPositionZ = 0.5
    showAtmosphericEffects = False
    showShadows3D = False
    dateTime = GetPythonClass('datetime', 'datetime')
    illuminationSource = IlluminationSource.AbsoluteSunPosition
    sunAzimuth = 315.0
    sunAltitude = 30.0
    showStars = True
    enableAmbientOcclusion = True
    enableEyeDomeLighting = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeAnalysis():
    """
      Represents an exploratory analysis keyframe.
    """
    analysis = 'CIMExploratoryAnalysisDefinition'
    transition = AnimationTransition.Linear
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeCamera():
    """
      Represents a camera keyframe.
    """
    camera = 'CIMViewCamera'
    headingTransition = AnimationTransition.AdjustableArc
    pitchTransition = AnimationTransition.AdjustableArc
    rollTransition = AnimationTransition.AdjustableArc
    scaleTransition = AnimationTransition.AdjustableArc
    xTransition = AnimationTransition.AdjustableArc
    yTransition = AnimationTransition.AdjustableArc
    zTransition = AnimationTransition.AdjustableArc
    transitionScale = 0.5
    cameraTransitionMode = esriAnimationTransitionMode.esriAnimationTransitionModeAuto
    lookAt = GetPythonClass('arcpy', 'Geometry')
    adjustedCameraPath = GetPythonClass('arcpy', 'Multipoint')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeElevationSource():
    """
      Represents an elevation source keyframe.
    """
    sourceID = str()
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeLayer():
    """
      Represents a layer keyframe.
    """
    layerURI = str()
    transparency = 0.0
    transparencyTransition = AnimationTransition.Linear
    visible = True
    swipeDirection = SwipeDirection.eNone
    swipePercent = 0.0
    verticalExaggeration = 1.0
    zOffset = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeRange():
    """
      Represents a range keyframe.
    """
    range = 'CIMRange'
    minTransition = AnimationTransition.Stepped
    maxTransition = AnimationTransition.Stepped
    isExclusion = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeSurface():
    """
      Represents a surface keyframe.
    """
    surfaceID = str()
    transition = AnimationTransition.Linear
    verticalExaggeration = 1.0
    visible = True
    swipeDirection = SwipeDirection.eNone
    swipePercent = 0.0
    baseSources = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKeyframeTime():
    """
      Represents a time keyframe.
    """
    time = TimeExtent
    endTimeTransition = AnimationTransition.Stepped
    startTimeTransition = AnimationTransition.Stepped
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLocator():
    """
      Represents properties of locator for the map.
    """
    locatorType = LocatorType.Locator
    name = str()
    locatorURI = str()
    suggestionsEnabled = False
    enabled = True
    suggestionsSupported = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapElevationSurface():
    """
      Represents a map elevation surface.
    """
    baseSources = []
    elevationMode = ElevationMode.CustomSurface
    name = str()
    verticalExaggeration = 1.0
    mapElevationID = str()
    color = 'CIMColor'
    enableSurfaceShading = False
    surfaceTINShadingMode = SurfaceTINShadingMode.Smooth
    visibility = True
    metadataURI = str()
    offset = 0.0
    expanded = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapStereoProperties():
    """
      Represents map stereo properties.
    """
    leftImage = 'CIMDataConnection'
    rightImage = 'CIMDataConnection'
    sourceType = StereoSourceType.StereoModel
    stereoModelCollection = 'CIMDataConnection'
    leftImageID = -1
    rightImageID = -1
    leftImageColorizer = 'CIMRasterColorizer'
    rightImageColorizer = 'CIMRasterColorizer'
    adjustColorizersInSync = False
    isInverted = False
    stereoModelDisplayMode = StereoModelDisplayMode.Default
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMapTimeDisplay():
    """
      Represents map time display.
    """
    currentTimeExtent = TimeExtent
    defaultTimeInterval = 0.0
    defaultTimeIntervalUnits = esriTimeUnits.esriTimeUnitsUnknown
    defaultTimeWindow = 0.0
    fullTimeExtent = TimeExtent
    timeReference = TimeReference
    timeValue = TimeValue
    hasLiveData = False
    timeRelation = esriTimeRelation.esriTimeRelationOverlaps
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleDatasetParameter():
    """
      Represents a rule dataset parameter.
    """
    dataConnection = 'CIMDataConnection'
    definitionExpression = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleLayerDescription():
    """
      Describes the validation rule properties for each layer in the 
      map.
    """
    layerURI = str()
    definitionExpression = str()
    enabled = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScale():
    """
      Represents a 2D scale or 3D Distance.
    """
    value = 0.0
    alias = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScaleFormat():
    """
      Represents the scale formatting options.
    """
    formatType = ScaleFormatType.Absolute
    separator = str()
    reverseOrder = False
    decimalPlacesThreshold = 100.0
    decimalPlaces = 2
    showThousandSeparator = True
    pageUnits = str()
    pageUnitValue = 1.0
    equalsSign = str()
    mapUnits = str()
    capitalizeUnits = False
    abbreviateUnits = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSliderSettings():
    """
      Represents slider settings.
    """
    sliderExtent = 'CIMRange'
    sliderExtentLocked = False
    startValueLocked = False
    endValueLocked = False
    flipVertically = False
    useWindowValue = False
    windowValue = 1.0
    windowUnit = str()
    stepUsesWindow = True
    stepIntervalValue = 1.0
    stepIntervalUnit = str()
    stepCount = 30.0
    stepOption = SliderStepType.Interval
    playWaitSeconds = 0.3
    playForward = True
    playRepeats = False
    playReverses = False
    fullExtentOption = SliderExtentType.AllLayers
    fullExtentLayerURI = str()
    fullExtentCustomRange = 'CIMRange'
    interactionMode = SliderInteractionMode.Slider
    useTimeSnapping = False
    timeSnapMode = TimeSnapMode.Single
    singleTimeSnapUnit = str()
    aliasExpressionLayerURI = str()
    isMinimized = False
    ignoreInactiveValues = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSnappingProperties():
    """
      Represents snapping properties.
    """
    xYTolerance = 10.0
    xYToleranceUnit = SnapXYToleranceUnit.SnapXYToleranceUnitPixel
    zTolerance = 0.0
    zToleranceEnabled = False
    snapToSketchEnabled = True
    snapRequestType = SnapRequestType.SnapRequestType_GeometricAndVisualSnapping
    geometricFeedbackColor = 'CIMColor'
    visualFeedbackColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMValidationRule():
    """
      Represents validation rule that can be configured for a layer or 
      standalone table to find features/rows that violates specified 
      validation constraints.
    """
    ruleID = str()
    title = str()
    notes = str()
    severity = 3
    tags = str()
    creationDate = GetPythonClass('datetime', 'datetime')
    createdBy = str()
    lastModifiedDate = GetPythonClass('datetime', 'datetime')
    lastModifiedBy = str()
    participatingLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMViewCamera():
    """
      Represents a view camera.
    """
    heading = 0
    pitch = 0
    roll = 0
    scale = 0
    x = 0
    y = 0
    z = 0
    viewportHeight = -1.0
    viewportWidth = -1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMViewKeyframe():
    """
      Represents a view keyframe.
    """
    trackTime = 0.0
    camera = 'CIMKeyframeCamera'
    layers = []
    range = 'CIMKeyframeRange'
    time = 'CIMKeyframeTime'
    surfaces = []
    exploratoryAnalysis = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMViewTrack():
    """
      Represents a animation view track.
    """
    name = str()
    keyframes = []
    screenGraphics = []
    referenceResolutionWidth = 0
    referenceResolutionHeight = 0
    exportType = str()
    frameRate = -1
    dataRateFactor = -1
    startFrameTime = -1
    endFrameTime = -1
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMMap(CIMDefinition):
    """
      Represents a map or scene.
    """
    defaultCamera = 'CIMViewCamera'
    illumination = 'CIMIlluminationProperties'
    layers = []
    standaloneTables = []
    stereoProperties = 'CIMMapStereoProperties'
    defaultViewingMode = MapViewingMode.Map
    mapType = MapType.Map
    rangeSliderSettings = 'CIMSliderSettings'
    timeSliderSettings = 'CIMSliderSettings'
    animationViewTracks = []
    locators = []
    validationRules = []
    mapContexts = []
    standaloneVideos = []
    """
      Represents a map or scene.
    """
    backgroundColor = 'CIMColor'
    bookmarks = []
    clipToFullExtent = False
    attribution = str()
    customFullExtent = GetPythonClass('arcpy', 'Polygon')
    datumTransforms = []
    defaultExtent = GetPythonClass('arcpy', 'Extent')
    defaultScale = 0.0
    defaultGlobeTransparency = 0.0
    defaultRotation = 0.0
    description = str()
    elevationSurfaces = []
    generalPlacementProperties = 'CIMGeneralPlacementProperties'
    scaleLevels = []
    snappingProperties = 'CIMSnappingProperties'
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    surfaceColor = 'CIMColor'
    timeDisplay = 'CIMMapTimeDisplay'
    enableNavigationBelowGround = False
    referenceScale = 0.0
    enableWraparound = False
    includeMaximumInScaleRanges = False
    colorModel = ColorModel.RGB
    scales = []
    scaleFormat = 'CIMScaleFormat'
    scaleDisplayFormat = ScaleDisplayFormat.Value
    hVDatumTransforms = list()
    useServiceLayerIDs = False
    groundToGridCorrection = 'CIMGroundToGridCorrection'
    clippingMode = ClippingMode.eNone
    customClippingShapeURI = str()
    layersExcludedFromClipping = []
    surfacesExcludedFromClipping = []
    clippingAreaBorderSymbol = 'CIMSymbolReference'
    nearPlaneClipDistanceMode = ClipDistanceMode.Automatic
    nearPlaneClipDistance = 0.0
    editingElevation = 'CIMEditingElevation'
    editingTemplateCollection = 'CIMEditingTemplateCollection'
    fieldMappings = []
    rGBColorProfile = str()
    cMYKColorProfile = str()
    simulateOverprint = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAnimationScreenGraphicGroup(CIMAnimationScreenGraphic):
    """
      Represents an animation screen graphic group container.
    """
    children = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCutAndFillEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a slice box exploratory analysis definition.
    """
    cutFillPlane = GetPythonClass('arcpy', 'Polygon')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplateCollection(CIMEditingTemplateCollectionItem):
    """
      Represents a collection of editing templates.
    """
    contents = []
    expanded = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplateReference(CIMEditingTemplateCollectionItem):
    """
      Represents a reference to an editing template.
    """
    layerURI = str()
    templateName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFieldComparison(CIMBaseComparison):
    """
      Represents a field comparison rule.
    """
    searchFieldName = str()
    valueFieldName = str()
    comparisonOperator = ComparisonOperator.IsEqual
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFieldComparisonExpression(CIMBaseComparison):
    """
      Represents a field comparison expression.
    """
    comparisons = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLineOfSightEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a line of sight exploratory analysis definition.
    """
    observer = GetPythonClass('arcpy', 'Point')
    targets = GetPythonClass('arcpy', 'Multipoint')
    maximumDistance = 200.0
    minimumDistance = 3.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReviewerValidationRule(CIMValidationRule):
    """
      Represents reviewer validation rule that can be configured for 
      a layer or standalone table to find features/rows that violates 
      specified validation constraints.
    """
    ruleDefinitionExpression = str()
    ignoreFields = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleLRSLayerDescription(CIMRuleLayerDescription):
    """
      Describes the validation rule properties for a location reference 
      layer in the map.
    """
    routeIDFieldName = str()
    fieldsToCompare = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleRouteLayerDescription(CIMRuleLRSLayerDescription):
    """
      Describes the validation rule properties for route layer in the 
      map.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSliceBoxEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a slice box exploratory analysis definition.
    """
    centerPoint = GetPythonClass('arcpy', 'Point')
    heading = 0
    height = 100
    width = 100
    depth = 100
    cullDirection = CullDirection.Inward
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSliceCylinderEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a slice cylinder exploratory analysis definition.
    """
    centerPoint = GetPythonClass('arcpy', 'Point')
    heading = 0.0
    pitch = 0.0
    height = 100.0
    width = 100.0
    cullDirection = CullDirection.Inward
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSlicePlaneEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a slice plane exploratory analysis definition.
    """
    centerPoint = GetPythonClass('arcpy', 'Point')
    heading = 0.0
    pitch = 0.0
    height = 100.0
    width = 100.0
    cullDirection = CullDirection.Inward
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSliceSphereEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a slice sphere exploratory analysis definition.
    """
    centerPoint = GetPythonClass('arcpy', 'Point')
    radius = 0.0
    cullDirection = CullDirection.Inward
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMViewDomeEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a view dome exploratory analysis definition.
    """
    observer = GetPythonClass('arcpy', 'Point')
    maximumDistance = 200.0
    minimumDistance = 3.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMViewshedEADefinition(CIMExploratoryAnalysisDefinition):
    """
      Represents a viewshed exploratory analysis definition.
    """
    observer = GetPythonClass('arcpy', 'Point')
    heading = 0.0
    pitch = 0.0
    horizontalAngle = 60.0
    verticalAngle = 60.0
    maximumDistance = 200.0
    minimumDistance = 3.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReviewerDependentValidationRule(CIMReviewerValidationRule):
    """
      Represents reviewer validation rule that can be configured for 
      a layer or standalone table to find features/rows that violates 
      specified validation constraints and depends on other layers or 
      table to do so.
    """
    secondaryDatasets = []
    secondaryLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReviewerIndependentValidationRule(CIMReviewerValidationRule):
    """
      Represents reviewer validation rule that can be configured for 
      a layer or standalone table to find features/rows that violates 
      specified validation constraints and does not depend on other layers 
      or table to do so.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMReviewerSimpleValidationRule(CIMReviewerValidationRule):
    """
      Represents a simple validation rule.
    """
    ruleType = ReviewerSimpleValidationRuleType.QueryAttributesRule
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleEventLayerDescription(CIMRuleLRSLayerDescription):
    """
      Describes the validation rule properties for event layer in the 
      map.
    """
    fromMeasureFieldName = str()
    toMeasureFieldName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubtypeRule(CIMReviewerIndependentValidationRule):
    """
      Represents rule that will identify invalid and null subtypes on 
      features.
    """
    checkNulls = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableToTableAttributeRule(CIMReviewerDependentValidationRule):
    """
      Represents rule that will identify records based on comparing attributes 
      values. It will take two inputs and some configuration parameter.
    """
    checkAttributes = True
    attributeComparisons = 'CIMFieldComparisonExpression'
    notQuery = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCutbacksRule(CIMReviewerIndependentValidationRule):
    """
      Represents a cutbacks rule which is used to detect high-angle turns 
      that cause features to turn back toward themselves.
    """
    minAngle = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDomainRule(CIMReviewerIndependentValidationRule):
    """
      Represents a domain rule which validates domain values to ensure 
      they meet all constraints for a field.
    """
    checkNulls = False
    domainFieldsToInclude = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDuplicateFeatureRule(CIMReviewerDependentValidationRule):
    """
      Duplicate Feature Rule will identify duplicate features based on 
      geometry and attributes of the input layers. It will take 2 inputs 
      and a configuration parameter.
    """
    fieldsToCompare = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEventOnEventRule(CIMReviewerDependentValidationRule):
    """
      Represents and event on event rule.
    """
    overlayEventsWhereClause = str()
    notQuery = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureOnFeatureRule(CIMReviewerDependentValidationRule):
    """
      Represents a feature on feature rule which validates features against 
      other features based on rule criteria.
    """
    spatialRelationship = esriSpatialRelEnum.esriSpatialRelIntersects
    customSpatialRelation = str()
    checkAttributes = False
    tolerance = 0.0
    toleranceUnits = str()
    notQuery = False
    mergeFeatures = False
    attributeComparisons = 'CIMFieldComparisonExpression'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMInvalidEventRule(CIMReviewerDependentValidationRule):
    """
      Represents an invalid event rule.
    """
    eventSourceRouteID = str()
    eventSourceFromMeasure = str()
    eventSourceToMeasure = str()
    routeSourceRouteID = str()
    findOrphans = False
    findGaps = False
    measureTolerance = 0.0
    findInvalidMeasures = False
    findOverlaps = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMonotonicityRule(CIMReviewerIndependentValidationRule):
    """
      Represents an monotonicity rule.
    """
    levelValuesAreError = False
    nonMonotonicValuesAreError = False
    evaluationType = ReviewerMonotonicityEvaluationType.EvaluateNone
    monotonicityDirection = ReviewerMonotonicityDirection.NoneAsError
    def __init__(self, *args, **Kwargs):
        pass
    
