﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMSchematicAlgorithm():
    """
      Represents a schematic algorithm.
    """
    algorihmPropertySet = {}
    algorithmCLSID = str()
    available = True
    label = str()
    overridable = True
    useEndNode = False
    useRootNode = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicAttribute():
    """
      Represents a schematic attribute.
    """
    attributeCLSID = str()
    description = str()
    evaluationMode = SchematicAttributeEvaluationMode.LoadEvaluation
    isPredefined = False
    name = str()
    parameters = {}
    storageFieldDescription = 'CIMFieldDescription'
    storageMode = SchematicAttributeStorage.FieldStorage
    storageName = str()
    storagePropertyName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicBuilder():
    """
      Represents a schematic builder.
    """
    autoCreateFeatureClasses = False
    builderCLSID = str()
    builderPropertySet = {}
    initializeLinkVertices = False
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicDataSource():
    """
      Represents a schematic data source.
    """
    dataSourceCLSID = str()
    dataSourceID = -2
    initString = str()
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicDataset():
    """
      Represents a schematic dataset.
    """
    is9xDataset = False
    name = str()
    schematicDataSources = []
    schematicDiagramTemplate = []
    schematicFeatureClasses = []
    workspace = 'CIMWorkspaceConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicDiagramTemplate():
    """
      Represents a diagram template.
    """
    alwaysLoadDiagram = False
    associatedSchematicFeatureClasses = []
    defaultSchematicAlgorithm = 'CIMSchematicAlgorithm'
    defaultSchematicNodeClassName = str()
    externalQueryEvaluationMode = SchematicExternalQueryEvaluationMode.NoQuery
    diagramTemplateID = -2
    identifierFieldNames = []
    name = str()
    predefinedAttributeNames = []
    queryString = str()
    schematicAlgorithms = []
    schematicAttributes = []
    schematicBuilder = 'CIMSchematicBuilder'
    schematicDataSourceID = -2
    schematicLayerTemplate = 'CIMSchematicLayer'
    schematicQueryParameters = []
    schematicRules = []
    schematicTraces = []
    tableName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicFeatureClass():
    """
      Represents a schematic feature class.
    """
    associatedObjectClassDataSourceID = -2
    associatedObjectClassID = -2
    externalQueryEvaluationMode = SchematicExternalQueryEvaluationMode.NoQuery
    geometryType = esriGeometryType.esriGeometryPoint
    featureClassID = -2
    identifierFieldNames = []
    name = str()
    parent = str()
    predefinedAttributeNames = []
    queryString = str()
    schematicAttributes = []
    schematicDataSourceID = -2
    schematicElementType = SchematicElementType.NodeType
    schematicQueryParameters = []
    shapeFieldDescription = 'CIMFieldDescription'
    tableName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicQueryParameter():
    """
      Represents a schematic query parameter.
    """
    isTextual = False
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSchematicRule():
    """
      Represents a schematic rule.
    """
    isActive = True
    orderNumber = -1
    ruleCLSID = str()
    rulePropertySet = {}
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMSchematicDataConnection(CIMDataConnection):
    """
      Represents a schematic data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a schematic data connection.
    """
    schematicDataset = str()
    diagramTemplate = str()
    diagram = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMSchematicLayer(CIMBaseLayer):
    """
      Represents a schematic layer.
    """
    layers = []
    schematicDiagram = 'CIMDataConnection'
    symbolLayerDrawing = 'CIMSymbolLayerDrawing'
    referenceScale = 1.0
    isTemplate = False
    def __init__(self, *args, **Kwargs):
        pass
    
