﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMIsosurface():
    """
      Represents a isosurface.
    """
    color = 'CIMColor'
    isCustomColor = False
    quadrantCutMask = 0
    sliceable = True
    value = 0
    variable = str()
    name = str()
    visible = True
    pinned = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMIsosurfaceGroup():
    """
      Represents a isosurface group.
    """
    isosurfaces = []
    expanded = False
    name = str()
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMIsosurfaceGroupContainer():
    """
      Represents a isosurface group container.
    """
    groups = []
    visible = True
    expanded = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObject3DRenderingFilter():
    """
      Represents a 3D object rendering filter.
    """
    iD = str()
    name = str()
    description = str()
    filterBlocks = []
    authoringInfo = 'CIMObject3DRenderingFilterAuthoringInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObject3DRenderingFilterAuthoringInfo():
    """
      Represents a filter authoring info.
    """
    isVisible = True
    filterBlocks = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObject3DRenderingFilterBlock():
    """
      Represents a 3D object rendering filter block.
    """
    title = str()
    mode = Object3DRenderingMode.eNone
    expression = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObject3DRenderingFilterBlockAuthoringInfo():
    """
      Represents a filter block authoring info.
    """
    filterStates = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMObject3DRenderingFilterState():
    """
      Represents a 3D object rendering filter value.
    """
    filterType = str()
    selectedValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMServerConnection():
    """
      Represents a server connection.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelDefinition():
    """
      Represents a voxel definition.
    """
    visibility = True
    expanded = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelFilter():
    """
      Represents a renderer filter.
    """
    variable = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelRenderer():
    """
      Represents a voxel renderer.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelSection():
    """
      Represents a voxel section.
    """
    name = str()
    visible = True
    expanded = False
    variable = str()
    renderer = 'CIMVoxelRenderer'
    voxelSlices = []
    sectionSliceIndex = 0
    rasterURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelSectionContainer():
    """
      Represents a voxel section container.
    """
    voxelSections = []
    expanded = False
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelSlice():
    """
      Represents a voxel slice.
    """
    name = str()
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelSliceContainer():
    """
      Represents a voxel slice container.
    """
    voxelSlices = []
    expanded = False
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelVariableProfile():
    """
      Represents a voxel layer variable profile.
    """
    variable = str()
    description = str()
    dataType = VoxelVariableDataType.Continuous
    filters = []
    renderer = 'CIMVoxelRenderer'
    precision = VoxelVariablePrecision.InputData
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMBuildingDisciplineSceneLayer(CIMBaseLayer):
    """
      Represents a building discipline scene layer.
    """
    subLayers = []
    subLayerID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBuildingSceneLayer(CIMBaseLayer):
    """
      Represents a building composite scene layer.
    """
    subLayers = []
    dataConnection = 'CIMDataConnection'
    """
      Represents a building composite scene layer.
    """
    filters = []
    activeFilterID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMSubLayerBase
class CIMDynamicServiceCompositeSubLayer(CIMSubLayerBase):
    """
      Represents a dynamic service composite sublayer.
    """
    subLayers = []
    """
      Represents a dynamic service composite sublayer.
    """
    definitionExpression = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDynamicServiceSubLayer(CIMSubLayerBase):
    """
      Represents a dynamic service sublayer.
    """
    showLabels = False
    scaleSymbols = False
    definitionExpression = str()
    sourceID = str()
    useTime = False
    drawTimeCumulative = False
    timeOffset = 0.0
    timeOffsetUnits = esriTimeUnits.esriTimeUnitsUnknown
    styleName = str()
    layerDefinition = str()
    popupInfo = 'CIMPopupInfo'
    showPopups = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSceneServiceLayer(CIMBaseLayer):
    """
      Represents a scene service layer.
    """
    serviceConnection = 'CIMAGSServiceConnection'
    snappable = True
    renderer = 'CIMRenderer'
    featureElevationExpression = str()
    labelClasses = []
    labelVisibility = False
    dataConnection = 'CIMSceneDataConnection'
    useRealWorldSymbolSizes = False
    exclusionSet = []
    definitionExpression = str()
    definitionExpressionName = str()
    definitionFilterChoices = []
    associatedFeatureLayerURI = str()
    sceneServiceLayerType = SceneServiceLayerType.Point
    selectable = True
    selectionSetURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMServiceConnection(CIMDataConnection):
    """
      Represents a service connection.
    """
    description = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMServiceLayer(CIMBaseLayer):
    """
      Represents a service layer.
    """
    serviceConnection = 'CIMServiceConnection'
    subLayers = []
    transparentColor = 'CIMColor'
    backgroundColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelLayer(CIMBaseLayer):
    """
      Represents a voxel layer.
    """
    dataConnection = 'CIMDataConnection'
    snappable = True
    selectedVariableProfileIndex = 0
    variableProfiles = []
    voxelDefinition = 'CIMVoxelDefinition'
    optimization = VoxelLayerOptimization.Visualization
    isosurfaceGroupContainer = 'CIMIsosurfaceGroupContainer'
    sliceContainer = 'CIMVoxelSliceContainer'
    sectionContainer = 'CIMVoxelSectionContainer'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWMSSubLayer(CIMSubLayerBase):
    """
      Represents a WMS service sublayer.
    """
    styleName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAGSServiceConnection(CIMServiceConnection):
    """
      Represents an ArcGIS Server service connection.
    """
    objectName = str()
    objectType = str()
    url = str()
    capabilities = str()
    serverConnection = 'CIMServerConnection'
    gdbVersion = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDCOMServerConnection(CIMServerConnection):
    """
      Represents a DCOM server connection.
    """
    domain = str()
    hideUserProperty = True
    machine = str()
    managerURL = str()
    password = str()
    user = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDynamicServiceLayer(CIMServiceLayer):
    """
      Represents a dynamic service layer.
    """
    imageFormat = esriImageFormat.esriImagePNG
    useTime = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGlobeServiceLayer(CIMServiceLayer):
    """
      Represents a globe service layer.
    """
    constantScreenSize = True
    snappable = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMInternetServerConnectionBase(CIMServerConnection):
    """
      Represents the internet server connection base class.
    """
    anonymous = True
    hideUserProperty = True
    password = str()
    url = str()
    user = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLANServerConnection(CIMServerConnection):
    """
      Represents a LAN service connection.
    """
    machine = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProjectServerConnection(CIMInternetServerConnectionBase):
    """
      Represents a project server connection.
    """
    connectionMode = ConnectionMode.Consumer
    name = str()
    serverType = ServerType.AGS
    stagingFolder = str()
    useDefaultStagingFolder = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardServiceConnection(CIMServiceConnection):
    """
      Represents a standard service connection.
    """
    serviceProvider = str()
    serviceType = str()
    url = str()
    culture = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTiledServiceLayer(CIMServiceLayer):
    """
      Represents a tiled service layer.
    """
    associatedFeatureLayerURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelCornerSlice(CIMVoxelSlice):
    """
      Represents a voxel corner slice.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelRangeValueFilter(CIMVoxelFilter):
    """
      Represents a voxel value filter.
        /// Filter based on the value of an specified variable.
    """
    min = 0
    max = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelStandardSlice(CIMVoxelSlice):
    """
      Represents a voxel standard slice.
    """
    position = GetPythonClass('arcpy', 'Point')
    normal = GetPythonClass('arcpy', 'Point')
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelStretchRenderer(CIMVoxelRenderer):
    """
      Represents a unique value renderer.
    """
    colorRamp = 'CIMColorRamp'
    minLabel = str()
    maxLabel = str()
    isDataFilterEnabled = False
    dataFilterMin = 0
    dataFilterMax = 0
    colorRangeMin = 0
    colorRangeMax = 0
    useTransparencyStops = False
    transparencyStopPositions = []
    transparencyStopValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelUniqueValueRenderer(CIMVoxelRenderer):
    """
      Represents a unique value renderer.
    """
    classes = []
    colorRamp = 'CIMColorRamp'
    heading = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVoxelValueFilter(CIMVoxelFilter):
    """
      Represents a voxel value filter.
        /// Filter based on the value of an specified variable.
    """
    values = []
    mode = VoxelValueFilterMode.Exclude
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWCSServiceConnection(CIMServiceConnection):
    """
      Represents a WCS service connection.
    """
    coverageName = str()
    version = str()
    serverConnection = 'CIMInternetServerConnectionBase'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWFSServiceConnection(CIMServiceConnection):
    """
      Represents a WFS service connection.
    """
    layerName = str()
    version = str()
    serverConnection = 'CIMInternetServerConnectionBase'
    capabilitiesParameters = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWMSServiceConnection(CIMServiceConnection):
    """
      Represents a WMS service connection.
    """
    layerName = str()
    version = str()
    serverConnection = 'CIMInternetServerConnectionBase'
    capabilitiesParameters = {}
    mapParameters = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWMTSServiceConnection(CIMServiceConnection):
    """
      Represents a WMTS service connection.
    """
    layerName = str()
    version = str()
    serverConnection = 'CIMInternetServerConnectionBase'
    style = str()
    dimensions = {}
    imageFormat = str()
    tileMatrixSet = str()
    capabilitiesParameters = {}
    mapParameters = {}
    templateUrl = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMInternetServerConnection(CIMInternetServerConnectionBase):
    def __init__(self, *args, **Kwargs):
        pass
    
