﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMClassBreak():
    """
      Represents a class break.
    """
    criticalBreak = False
    description = str()
    label = str()
    patch = PatchShape.Default
    symbol = 'CIMSymbolReference'
    upperBound = 0
    alternateSymbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMExpressionInfo():
    """
      Represents the properties required for authoring an Arcade expression.
    """
    title = str()
    expression = str()
    name = str()
    returnType = ExpressionReturnType.Default
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPrimitiveOverride():
    """
      Represents a primitive override.
    """
    primitiveName = str()
    propertyName = str()
    expression = str()
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProportionalPieSizeOptions():
    """
      Represents proportional pie size options.
    """
    flanneryCompensation = True
    minimumSize = 12.0
    minimumValue = 0
    proportionalBySum = True
    proportionalFieldName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRenderer():
    """
      Represents a renderer.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleSymbolLayerNames():
    """
      Represents rule symbol layer names.
    """
    ruleID = 0
    symbolLayerNames = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMScaleDependentSizeVariation():
    """
      Represents the scale dependent size variations for a symbol reference.
    """
    scale = 0.0
    size = 4.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStringMap():
    """
      Represents a string map of key value pairs.
    """
    key = str()
    value = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolReference():
    """
      Represents a symbol reference.
    """
    primitiveOverrides = []
    stylePath = str()
    symbol = 'CIMSymbol'
    symbolName = str()
    minScale = 0.0
    maxScale = 0.0
    scaleDependentSizeVariation = []
    minDistance = 0.0
    maxDistance = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolizationRule():
    """
      Represents a symbolization rule.
    """
    minScale = 0.0
    maxScale = 0.0
    filter = str()
    symbol = 'CIMSymbolReference'
    label = str()
    description = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMUniqueValue():
    """
      Represents a unique value.
    """
    fieldValues = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMUniqueValueClass():
    """
      Represents a unique value class.
    """
    description = str()
    editable = False
    label = str()
    patch = PatchShape.Default
    symbol = 'CIMSymbolReference'
    values = []
    visible = True
    alternateSymbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMUniqueValueGroup():
    """
      Represents a unique value group.
    """
    classes = []
    heading = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMUnitSymbolization():
    """
      Represents unit symbolization.
    """
    valueRepresentation = ValueRepresentations.Radius
    valueUnit = str()
    symbolShape = SymbolShapes.Circle
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVisualVariable():
    """
      Represents a visual variable.
    """
    authoringInfo = 'CIMVisualVariableAuthoringInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVisualVariableAuthoringInfo():
    """
      Represents visual variable metadata used for authoring.
    """
    minSliderValue = 0.0
    maxSliderValue = 0.0
    theme = str()
    showLegend = False
    heading = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVisualVariableInfo():
    """
      Represents visual variable info.
    """
    expression = str()
    randomMax = 1.0
    randomMin = 0.0
    visualVariableInfoType = VisualVariableInfoType.eNone
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVisualVariableLevel():
    """
      Represents a level-of-detail for a multilevel visual variable.
    """
    iD = -1
    minValue = 0.0
    maxValue = 1.0
    mean = 0.0
    standardDeviation = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartRenderer(CIMRenderer):
    """
      Represents chart renderer which contains properties common to all 
      symbolizers that depict some feature value as a chart drawn on 
      top of the feature itself.
    """
    barrierWeight = BarrierWeight.High
    baseSymbol = 'CIMSymbolReference'
    chartSymbol = 'CIMSymbolReference'
    fieldNames = []
    fieldTotals = []
    label = str()
    maxValue = 0
    preventChartOverlap = True
    proportionalPieSizeOptions = 'CIMProportionalPieSizeOptions'
    colorRamp = 'CIMColorRamp'
    fieldLabels = []
    showSizeLegend = True
    sizeLegendOutlineColor = 'CIMColor'
    sizeLegendLeaderlineColor = 'CIMColor'
    """
      Represents chart renderer which contains properties common to all 
      symbolizers that depict some feature value as a chart drawn on 
      top of the feature itself.
    """
    normalizationField = str()
    normalizationTotal = 0.0
    normalizationType = DataNormalizationMethod.Nothing
    """
      Represents chart renderer which contains properties common to all 
      symbolizers that depict some feature value as a chart drawn on 
      top of the feature itself.
    """
    exclusionClause = str()
    exclusionDescription = str()
    exclusionLabel = str()
    exclusionSymbol = 'CIMSymbolReference'
    useExclusionSymbol = True
    exclusionSymbolPatch = PatchShape.Default
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMClassBreaksRendererBase(CIMRenderer):
    """
      The base class for class breaks renderer types.
    """
    backgroundSymbol = 'CIMSymbolReference'
    barrierWeight = BarrierWeight.High
    breaks = []
    classBreakType = ClassBreakType.GraduatedColor
    classificationMethod = ClassificationMethod.NaturalBreaks
    colorRamp = 'CIMColorRamp'
    field = str()
    minimumBreak = 0
    numberFormat = 'CIMNumberFormat'
    showClassGaps = False
    showInAscendingOrder = True
    heading = str()
    sampleSize = 10000
    useDefaultSymbol = False
    defaultSymbolPatch = PatchShape.Default
    defaultSymbol = 'CIMSymbolReference'
    minimumLabel = str()
    defaultLabel = str()
    defaultDescription = str()
    valueExpressionInfo = 'CIMExpressionInfo'
    polygonSymbolColorTarget = PolygonSymbolColorTarget.Fill
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorVisualVariable(CIMVisualVariable):
    """
      Represents a color visual variable.
    """
    expression = str()
    minValue = 0.0
    maxValue = 1.0
    colorRamp = 'CIMColorRamp'
    normalizationField = str()
    normalizationType = DataNormalizationMethod.Nothing
    valueExpressionInfo = 'CIMExpressionInfo'
    polygonSymbolColorTarget = PolygonSymbolColorTarget.Fill
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDictionaryRenderer(CIMRenderer):
    """
      Represents a dictionary renderer where symbols are drawn from a 
      symbol dictionary.
    """
    dictionaryName = str()
    fieldMap = []
    scalingExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDotDensityRenderer(CIMRenderer):
    """
      Represents a dot density renderer.
    """
    visualVariables = []
    """
      Represents a dot density renderer.
    """
    exclusionClause = str()
    exclusionDescription = str()
    exclusionLabel = str()
    exclusionSymbol = 'CIMSymbolReference'
    useExclusionSymbol = True
    exclusionSymbolPatch = PatchShape.Default
    """
      Represents a dot density renderer.
    """
    colorRamp = 'CIMColorRamp'
    dotDensitySymbol = 'CIMSymbolReference'
    dotSize = 2.0
    dotValue = 0.0
    excludeDotsFromMaskedArea = False
    fieldNames = []
    fieldLabels = []
    fixedPlacement = True
    maintainDensity = False
    maskingLayer = str()
    randomSeed = 0
    referenceScale = 0.0
    useMasking = False
    valueExpressionInfos = []
    sampleSize = 10000
    symbolLabel = str()
    unitLabel = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHeatMapRenderer(CIMRenderer):
    """
      Represents a heat map renderer.
        /// The Heat Map Renderer draws point features as a continuous 
      /// color gradient representing the density of the points. The 
      resulting /// density surface represents the physical proximity 
      between points, /// optionally weighted by a specified attribute 
      value. The displayed /// raster surface is dynamic and morphs according 
      to the zoom level /// and updates if the source point features 
      are edited.
    """
    colorScheme = 'CIMColorRamp'
    field = str()
    radius = 10
    rendererQuality = 7
    heading = str()
    minLabel = str()
    maxLabel = str()
    maxPixelIntensity = 0.0
    pixelIntensityStops = []
    autoAdjustPixelIntensity = True
    maxPixelIntensityReferenceScale = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultilevelVisualVariable(CIMVisualVariable):
    """
      Represents a visual variable with different levels-of-detail, each 
      with its own minimum and maximum data values. Used for binning 
      layers.
    """
    levels = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMProportionalRenderer(CIMRenderer):
    """
      Represents a proportional renderer.
    """
    visualVariables = []
    """
      Represents a proportional renderer.
    """
    normalizationField = str()
    normalizationTotal = 0.0
    normalizationType = DataNormalizationMethod.Nothing
    """
      Represents a proportional renderer.
    """
    exclusionClause = str()
    exclusionDescription = str()
    exclusionLabel = str()
    exclusionSymbol = 'CIMSymbolReference'
    useExclusionSymbol = True
    exclusionSymbolPatch = PatchShape.Default
    """
      Represents a proportional renderer.
    """
    backgroundSymbol = 'CIMSymbolReference'
    barrierWeight = BarrierWeight.High
    field = str()
    flanneryCompensation = False
    legendSymbolCount = 3
    maxDataValue = 0
    minDataValue = 0
    minSymbol = 'CIMSymbolReference'
    unitSymbolization = 'CIMUnitSymbolization'
    heading = str()
    useDefaultSymbol = False
    defaultSymbol = 'CIMSymbolReference'
    defaultSymbolPatch = PatchShape.Default
    defaultLabel = str()
    defaultDescription = str()
    showInAscendingOrder = False
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRepresentationRenderer(CIMRenderer):
    """
      Represents a representation renderer.
    """
    drawInvalidRule = True
    drawInvisibleRepresentation = False
    invalidRuleColor = 'CIMColor'
    invisibleRepresentationColor = 'CIMColor'
    representationClassName = str()
    ruleLegendVisibility = []
    symbolLayerNameMapping = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRotationVisualVariable(CIMVisualVariable):
    """
      Represents a rotation visual variable.
    """
    visualVariableInfoX = 'CIMVisualVariableInfo'
    visualVariableInfoY = 'CIMVisualVariableInfo'
    visualVariableInfoZ = 'CIMVisualVariableInfo'
    rotationTypeZ = SymbolRotationType.Arithmetic
    normalToSurface = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRuleRenderer(CIMRenderer):
    """
      Represents a rule renderer.
    """
    visualVariables = []
    """
      Represents a rule renderer.
    """
    rules = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSimpleRenderer(CIMRenderer):
    """
      Represents a simple renderer.
    """
    visualVariables = []
    """
      Represents a simple renderer.
    """
    description = str()
    label = str()
    patch = PatchShape.Default
    symbol = 'CIMSymbolReference'
    alternateSymbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSizeVisualVariable(CIMVisualVariable):
    """
      Represents a size visual variable.
    """
    expression = str()
    randomMin = 0.0
    randomMax = 1.0
    minSize = 0.0
    maxSize = 1.0
    minValue = 0.0
    maxValue = 1.0
    valueUnits = str()
    valueRepresentation = ValueRepresentations.Radius
    variableType = SizeVisualVariableType.eNone
    valueShape = SymbolShapes.Unknown
    axis = SizeVisualVariableAxis.HeightAxis
    target = str()
    normalizationField = str()
    normalizationType = DataNormalizationMethod.Nothing
    sizeValues = []
    dataValues = []
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTransparencyVisualVariable(CIMVisualVariable):
    """
      Represents a transparency visual variable.
    """
    field = str()
    transparencyValues = []
    dataValues = []
    normalizationField = str()
    normalizationTotal = 0.0
    normalizationType = DataNormalizationMethod.Nothing
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMUniqueValueRenderer(CIMRenderer):
    """
      Represents a unique value renderer.
    """
    visualVariables = []
    """
      Represents a unique value renderer.
    """
    colorRamp = 'CIMColorRamp'
    defaultDescription = str()
    defaultLabel = str()
    defaultSymbol = 'CIMSymbolReference'
    defaultSymbolPatch = PatchShape.Default
    fields = []
    groups = []
    useDefaultSymbol = False
    styleGallery = str()
    valueExpressionInfo = 'CIMExpressionInfo'
    polygonSymbolColorTarget = PolygonSymbolColorTarget.Fill
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMClassBreaksRenderer(CIMClassBreaksRendererBase):
    """
      Represents a class break renderer.
    """
    normalizationField = str()
    normalizationTotal = 0.0
    normalizationType = DataNormalizationMethod.Nothing
    """
      Represents a class break renderer.
    """
    exclusionClause = str()
    exclusionDescription = str()
    exclusionLabel = str()
    exclusionSymbol = 'CIMSymbolReference'
    useExclusionSymbol = True
    exclusionSymbolPatch = PatchShape.Default
    """
      Represents a class break renderer.
    """
    visualVariables = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultilevelColorVisualVariable(CIMMultilevelVisualVariable):
    """
      Represents a color visual variable with different levels-of-detail.
    """
    colorRamp = 'CIMColorRamp'
    normalizationField = str()
    normalizationType = DataNormalizationMethod.Nothing
    valueExpressionInfo = 'CIMExpressionInfo'
    polygonSymbolColorTarget = PolygonSymbolColorTarget.Fill
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultilevelSizeVisualVariable(CIMMultilevelVisualVariable):
    """
      Represents a size visual variable with different levels-of-detail.
    """
    minSize = 0.0
    maxSize = 1.0
    valueRepresentation = ValueRepresentations.Radius
    variableType = SizeVisualVariableType.eNone
    valueShape = SymbolShapes.Unknown
    axis = SizeVisualVariableAxis.HeightAxis
    target = str()
    normalizationField = str()
    normalizationType = DataNormalizationMethod.Nothing
    valueExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
