﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMColorClassBreak():
    """
      Represents a color class break.
    """
    upperBound = 0.0
    label = str()
    description = str()
    color = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorModulationInfo():
    """
      Indicates whether modulation should be used to render the point. 
      Low modulation values will darken the point color.
    """
    field = str()
    minValue = 0.0
    maxValue = 255.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorUniqueValue():
    """
      Represents a color unique value.
    """
    value = str()
    label = str()
    description = str()
    color = 'CIMColor'
    visible = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASPointSplatter():
    """
      Represents a LAS point splatter.
    """
    splatMinimumSize = 4.0
    splatScale = 1.0
    useSplatHighlight = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASStretchClass():
    """
      Represents a LAS stretch class.
    """
    label = str()
    value = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASStretchInput():
    """
      Represents LAS stretch input.
    """
    colorRamp = 'CIMColorRamp'
    stretchMax = 1.0
    stretchMin = 0.0
    gammaValue = 1.0
    invert = False
    lookup = []
    maxPercent = 2.0
    minPercent = 2.0
    numberFormat = 'CIMNumberFormat'
    standardDeviationParam = 2.0
    statsType = LASStretchStatsType.Dataset
    stretchAttribute = LASStretchAttribute.Elevation
    stretchClasses = []
    stretchStats = StatsHistogram
    stretchType = LASStretchType.DefaultFromSource
    useCustomStretchMinMax = False
    useGammaStretch = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudAlgorithm():
    """
      Represents a point cloud algorithm.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudFilter():
    """
      Represents a point cloud filter.
    """
    field = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudRenderer():
    """
      Represents a point cloud renderer.
    """
    pointShape = PointCloudShapeType.DiskFlat
    pointSizeAlgorithm = 'CIMPointCloudAlgorithm'
    colorModulation = 'CIMColorModulationInfo'
    fieldTransformType = PointCloudFieldTransformType.eNone
    field = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinRenderer():
    """
      Represents a TIN renderer.
    """
    illuminate = False
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMLASDatasetLayer(CIMBaseLayer):
    """
      Represents a LAS dataset layer.
    """
    analysisToolsResolution = 1.0
    dataConnection = 'CIMDataConnection'
    displayField = str()
    fileExtentSymbol = 'CIMSymbolReference'
    fileNameSymbol = 'CIMSymbolReference'
    fullResolutionScale = 1000.0
    isFlattened = False
    lASDatasetFilter = str()
    maintainCurrentSurface = False
    pointBudget = 800000
    pointCountPerCentimeter = 6
    renderers = []
    scaleSymbols = True
    showFileExtent = False
    showFileName = False
    showResolution = True
    useFullResolutionScale = False
    selectable = False
    eyeDomeLighting = 'CIMEyeDomeLighting'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudLayer(CIMBaseLayer):
    """
      Represents a point cloud layer.
    """
    renderer = 'CIMPointCloudRenderer'
    dataConnection = 'CIMSceneDataConnection'
    pointsPerInch = 10
    pointsBudget = 1000000
    filters = []
    snappable = True
    eyeDomeLighting = 'CIMEyeDomeLighting'
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMSceneDataConnection(CIMDataConnection):
    """
      Represents a scene data connection.
    """
    uRI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainLayer(CIMBaseLayer):
    """
      Represents a terrain layer.
    """
    analysisToolsResolution = 0
    autoLOR = False
    currentResolution = 0
    dataConnection = 'CIMDataConnection'
    displayField = str()
    lockCurrentSurface = False
    pointBudget = 0
    pyramidHonored = False
    scaleSymbols = False
    showResolution = False
    renderers = []
    targetResolution = 0
    useOverviewTerrain = False
    usePointBudget = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinLayer(CIMBaseLayer):
    """
      Represents a TIN layer which displays TIN data sources, a data 
      structure that represents terrain data as a triangulated irregular 
      network.
    """
    dataConnection = 'CIMDataConnection'
    displayField = str()
    renderers = []
    scaleSymbols = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudBitFieldFilter(CIMPointCloudFilter):
    """
      Represents a point cloud bit field filter.
        /// Filters based on the bit-wise representation of the provided 
      field. /// For a point to be retained, its attribute field bits 
      must match /// BitsToSet and BitsToClear. Bits which are not explicitly 
      clear nor /// set, are ignored.
    """
    requiredSetBits = []
    requiredClearBits = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudClassBreaksRenderer(CIMPointCloudRenderer):
    """
      Represents a point cloud class breaks renderer.
    """
    breaks = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudFixedSizeAlgorithm(CIMPointCloudAlgorithm):
    """
      Represents a point cloud fixed size algorithm.
    """
    useRealWorldSymbolSizes = False
    size = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudRGBRenderer(CIMPointCloudRenderer):
    """
      Represents a point cloud RGB renderer.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudReturnFilter(CIMPointCloudFilter):
    """
      Represents a point cloud return filter.
    """
    includedReturnsBitmask = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudSplatAlgorithm(CIMPointCloudAlgorithm):
    """
      Represents a point cloud splat algorithm.
    """
    scaleFactor = 1.0
    minSize = 4.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudStretchRenderer(CIMPointCloudRenderer):
    """
      Represents a point cloud stretch renderer.
    """
    rangeMin = 0.0
    rangeMax = 500.0
    colorRamp = 'CIMColorRamp'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudUniqueValueRenderer(CIMPointCloudRenderer):
    """
      Represents a point cloud unique value renderer.
    """
    classes = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPointCloudValueFilter(CIMPointCloudFilter):
    """
      Represents a point cloud value filter.
        /// Filter points based on the value of an specified attribute.
    """
    values = []
    mode = PointCloudValueFilterMode.Exclude
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainAttributeRenderer(CIMTinRenderer):
    """
      Represents a terrain attribute renderer.
    """
    attributeFieldName = str()
    embeddedDataSources = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinColorRampRenderer(CIMTerrainAttributeRenderer):
    """
      Represents a TIN color ramp renderer.
    """
    breaks = []
    classificationMethod = ClassificationMethod.NaturalBreaks
    colorRamp = 'CIMColorRamp'
    cursorType = TerrainDrawCursorType.Composite
    description = str()
    label = str()
    minimumBreak = 0
    numberFormat = 'CIMNumberFormat'
    showClassGaps = False
    sortClassesAscending = False
    symbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinContourRenderer(CIMTinRenderer):
    """
      Represents a TIN contour renderer.
    """
    contourDescription = str()
    contourInterval = 0
    contourLabel = str()
    contourSymbol = 'CIMSymbolReference'
    indexContourDescription = str()
    indexContourFactor = 0
    indexContourLabel = str()
    indexContourSymbol = 'CIMSymbolReference'
    referenceContourHeight = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinFaceClassBreaksRenderer(CIMTinColorRampRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinNodeElevationRenderer(CIMTinColorRampRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinSimpleRenderer(CIMTinRenderer):
    """
      Represents a TIN simple renderer.
    """
    description = str()
    label = str()
    symbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinUniqueValueRenderer(CIMTerrainAttributeRenderer):
    """
      Represents a TIN unique value renderer.
    """
    colorScheme = str()
    description = str()
    groups = []
    heading = str()
    label = str()
    lookupStyleset = str()
    symbol = 'CIMSymbolReference'
    useDefaultSymbol = False
    colorRamp = 'CIMColorRamp'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASPointElevationRenderer(CIMTinColorRampRenderer):
    """
      Represents a LAS point elevation renderer.
    """
    modulateIntensity = False
    pointSplatter = 'CIMLASPointSplatter'
    useSplat = False
    colorModulation = 'CIMColorModulationInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASStretchRenderer(CIMTerrainAttributeRenderer):
    """
      Represents a LAS stretch renderer.
    """
    modulationInput = 'CIMLASStretchInput'
    modulationWeight = 0.0
    pointSplatter = 'CIMLASPointSplatter'
    stretchDrawingType = LASStretchDrawingType.Symbol
    stretchSourceInput = 'CIMLASStretchInput'
    tintSymbol = 'CIMSymbolReference'
    useModulation = False
    useSplat = False
    colorModulation = 'CIMColorModulationInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLASUniqueValueRenderer(CIMTinUniqueValueRenderer):
    """
      Represents a LAS unique value renderer.
    """
    attribute = 32
    modulateIntensity = False
    pointSplatter = 'CIMLASPointSplatter'
    useSplat = False
    colorModulation = 'CIMColorModulationInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainDirtyAreaRenderer(CIMTinSimpleRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainPointAttributeGraduatedRenderer(CIMTinColorRampRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainPointAttributeUniqueRenderer(CIMTinUniqueValueRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTerrainPointElevationRenderer(CIMTinColorRampRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinBreaklineRenderer(CIMTinUniqueValueRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinEdgeRenderer(CIMTinSimpleRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinFaceRenderer(CIMTinSimpleRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinFaceValueRenderer(CIMTinUniqueValueRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinNodeRenderer(CIMTinSimpleRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTinNodeValueRenderer(CIMTinUniqueValueRenderer):
    def __init__(self, *args, **Kwargs):
        pass
    
