﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMActivity():
    """
      Represents activity.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBindVariable():
    """
      Represents a bind variable.
    """
    variableName = str()
    alias = str()
    dataType = BindVariableType.String
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBinningVisualization():
    """
      Describes the appearance and application behavior of polygon aggregation 
      bins.
    """
    renderer = 'CIMRenderer'
    labelClass = 'CIMLabelClass'
    showLabels = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCondition():
    """
      Represents a condition.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDataConnection():
    """
      Represents a data connection.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDimensionShape():
    """
      Represents a dimension shape as used by a dimension feature.
    """
    beginDimensionPoint = GetPythonClass('arcpy', 'Point')
    endDimensionPoint = GetPythonClass('arcpy', 'Point')
    dimensionLinePoint = GetPythonClass('arcpy', 'Point')
    textPoint = GetPythonClass('arcpy', 'Point')
    extensionLineAngle = 0.0
    textAngle = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDimensionStyle():
    """
      Represents an dimension style which defines dimension appearance.
    """
    align = False
    baselineHeight = 0
    beginMarkerSymbol = 'CIMPointSymbol'
    convertUnits = False
    dimensionLineOption = DimensionPartOptions.Begin
    dimensionLineSymbol = 'CIMLineSymbol'
    displayPrecision = 0
    displayUnits = str()
    drawLineOnFit = False
    endMarkerSymbol = 'CIMPointSymbol'
    expression = str()
    expressionParserName = str()
    extendLineOnFit = False
    extensionLineOffset = 0
    extensionLineOption = DimensionPartOptions.Begin
    extensionLineOvershot = 0
    extensionLineSymbol = 'CIMLineSymbol'
    iD = 0
    markerFit = DimensionMarkerFit.eNone
    markerFitTolerance = 0
    markerOption = DimensionPartOptions.Begin
    name = str()
    prefix = str()
    suffix = str()
    textFit = DimensionTextFit.eNone
    textOption = DimensionTextOption.Only
    textSymbol = 'CIMTextSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDisplayFilter():
    """
      Represents a display filter used to restrict the display of features 
      across scale ranges.
    """
    name = str()
    whereClause = str()
    minScale = 0.0
    maxScale = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDisplayTable():
    """
      Represents a display table.
    """
    definitionExpression = str()
    definitionExpressionName = str()
    definitionFilterChoices = []
    displayField = str()
    editable = True
    relates = []
    fieldDescriptions = []
    timeFields = 'CIMTimeTableDefinition'
    timeDefinition = 'CIMTimeDataDefinition'
    timeDisplayDefinition = 'CIMTimeDisplayDefinition'
    timeDimensionFields = 'CIMTimeDimensionDefinition'
    rangeDefinitions = []
    activeRangeName = str()
    selectRelatedData = False
    bindVariables = []
    subtypeValue = 0
    useSubtypeValue = False
    displayExpressionInfo = 'CIMExpressionInfo'
    selectionSetURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplate():
    """
      Represents an editing template.
    """
    description = str()
    name = str()
    tags = str()
    toolProgID = str()
    toolFilter = []
    toolOptions = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplateRelationship():
    """
      Represents an editing template relationship.
    """
    tableURI = str()
    name = str()
    relationshipID = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEditingTemplateToolOptions():
    """
      Represents editing template tool options.
    """
    toolProgID = str()
    options = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureExtrusion():
    """
      Represents feature extrusion.
    """
    extrusionType = ExtrusionType.eNone
    extrusionExpression = str()
    extrusionUnit = str()
    extrusionExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureHyperlink():
    """
      Represents feature hyperlink.
    """
    featureID = -1
    link = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureReduction():
    """
      Represents a technique for visually reducing large numbers of features 
      in a map.
    """
    enabled = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFieldDescription():
    """
      Represents a field description.
    """
    alias = str()
    fieldName = str()
    highlight = False
    numberFormat = 'CIMNumberFormat'
    readOnly = False
    visible = True
    valueAsRatio = False
    searchable = False
    searchMode = DataSearchMode.Exact
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFolderConnection():
    """
      Represents a folder connection.
    """
    folderConnectionString = str()
    alias = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupEditingTemplatePart():
    """
      Represents a group editing template part.
    """
    layerURI = str()
    name = str()
    transformationID = str()
    options = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHtmlPopupFormat():
    """
      Represents an HTML pop-up format.
    """
    htmlRedirectField = str()
    htmlRedirectFieldPrefix = str()
    htmlRedirectFieldSuffix = str()
    htmlXSLStyleSheet = str()
    htmlHideFieldNameColumn = False
    htmlUseCodedDomainValues = False
    htmlPresentationStyle = HtmlPopupStyle.TwoColumnTable
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerAction():
    """
      Represents a layer action.
    """
    name = str()
    activities = []
    conditions = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerRange():
    """
      Represents a layer range.
    """
    layerURI = str()
    rangeName = str()
    currentRange = 'CIMRange'
    isExclusion = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMediaInfo():
    """
      Represents media info.
    """
    row = 0
    column = 0
    refreshRate = 0.0
    refreshRateUnit = esriTimeUnits.esriTimeUnitsSeconds
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultipatchFeatureTemplateModel():
    """
      Represents a multipatch feature template model.
    """
    isActive = False
    modelURI = str()
    modelSourceURI = str()
    thumbnailURI = str()
    camera = 'CIMViewCamera'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPageDefinition():
    """
      Represents page definition.
    """
    pageFieldName = str()
    excludePages = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPopupInfo():
    """
      Represents pop-up info.
    """
    title = str()
    expressionInfos = []
    mediaInfos = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRange():
    """
      Represents a range.
    """
    min = 0.0
    max = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRangeDefinition():
    """
      Represents a range definition.
    """
    name = str()
    fieldName = str()
    currentRange = 'CIMRange'
    customFullExtent = 'CIMRange'
    isExclusion = False
    aliasExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRelateInfoBase():
    """
      Represents relate base.
    """
    dataConnection = 'CIMDataConnection'
    foreignKey = str()
    primaryKey = str()
    cardinality = esriRelCardinality.esriRelCardinalityManyToMany
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolIdentifier():
    """
      Represents a symbol identifier.
    """
    iD = 0
    name = str()
    symbol = 'CIMSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayerMasking():
    """
      Represents symbol layer masking.
    """
    symbolLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTimeDataDefinition():
    """
      Represents a time data definition.
    """
    useTime = False
    timeReference = TimeReference
    customTimeExtent = TimeExtent
    hasLiveData = False
    timeExtentCanChange = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTimeDimensionDefinition():
    """
      Represents a time dimension definition.
    """
    timeDimensionName = str()
    timeDimensionFormat = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTimeDisplayDefinition():
    """
      Represents a time display definition.
    """
    cumulative = False
    timeInterval = 1.0
    timeIntervalUnits = esriTimeUnits.esriTimeUnitsUnknown
    timeOffset = 0.0
    timeOffsetUnits = esriTimeUnits.esriTimeUnitsUnknown
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTimeTableDefinition():
    """
      Represents a time table definition.
    """
    startTimeField = str()
    endTimeField = str()
    timeValueFormat = str()
    trackIDField = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMSubLayerBase
class CIMAnnotationSubLayer(CIMSubLayerBase):
    """
      Represents an annotation sublayer used to draw annotation feature 
      classes subclasses.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMLayer import CIMBaseLayer
class CIMBasicFeatureLayer(CIMBaseLayer):
    """
      Represents a basic feature layer, the base class for all layer 
      types that draw feature classes as features.
    """
    autoGenerateFeatureTemplates = False
    extrusion = 'CIMFeatureExtrusion'
    featureElevationExpression = str()
    featureHyperlinks = []
    featureTable = 'CIMFeatureTable'
    featureTemplates = []
    hotlinkField = str()
    htmlPopupEnabled = False
    htmlPopupFormat = 'CIMHtmlPopupFormat'
    isFlattened = False
    selectable = True
    selectionColor = 'CIMColor'
    selectionSymbol = 'CIMSymbolReference'
    useSelectionSymbol = False
    pageDefinition = 'CIMPageDefinition'
    featureCacheType = FeatureCacheType.eNone
    enableDisplayFilters = False
    displayFilters = []
    featureElevationExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBuildingDisciplineLayer(CIMBaseLayer):
    """
      Represents a building discipline layer.
    """
    disciplineType = DisciplineType.Architectural
    categoryLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBuildingLayer(CIMBaseLayer):
    """
      Represents a building composite layer.
    """
    buildingDisciplineLayers = []
    exteriorLayer = str()
    buildingID = str()
    dataConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMParcelFabricLayer(CIMBaseLayer):
    """
      Represents a parcel fabric layer.
    """
    accuracyTable = str()
    allLayers = []
    adjustmentsTable = str()
    cadastralFabricConnection = 'CIMDataConnection'
    controlPointLayer = str()
    controlPointSelectionSymbol = 'CIMSymbolReference'
    jobsTable = str()
    lineLayer = str()
    linePointLayer = str()
    lockedParcelSelectionSymbol = 'CIMSymbolReference'
    parcelLayer = str()
    plansTable = str()
    pointLayer = str()
    unlockedParcelSelectionSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMParcelLayer(CIMBaseLayer):
    """
      Represents a parcel fabric layer.
    """
    recordsLayer = str()
    dirtyAreaLayer = str()
    pointErrorLayer = str()
    lineErrorLayer = str()
    polygonErrorLayer = str()
    parcelConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMStandaloneTable(CIMDefinition):
    """
      Represents a standalone table.
    """
    definitionExpression = str()
    definitionExpressionName = str()
    definitionFilterChoices = []
    displayField = str()
    editable = True
    relates = []
    fieldDescriptions = []
    timeFields = 'CIMTimeTableDefinition'
    timeDefinition = 'CIMTimeDataDefinition'
    timeDisplayDefinition = 'CIMTimeDisplayDefinition'
    timeDimensionFields = 'CIMTimeDimensionDefinition'
    rangeDefinitions = []
    activeRangeName = str()
    selectRelatedData = False
    bindVariables = []
    subtypeValue = 0
    useSubtypeValue = False
    displayExpressionInfo = 'CIMExpressionInfo'
    selectionSetURI = str()
    """
      Represents a standalone table.
    """
    dataConnection = 'CIMDataConnection'
    description = str()
    autoGenerateRowTemplates = False
    rowTemplates = []
    serviceTableID = -1
    showPopups = True
    popupInfo = 'CIMPopupInfo'
    charts = []
    pageDefinition = 'CIMPageDefinition'
    customProperties = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVectorTileLayer(CIMBaseLayer):
    """
      Represents a VectorTile layer.
    """
    dataConnection = 'CIMVectorTileDataConnection'
    currentStyle = str()
    associatedFeatureLayerURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAggregateField(CIMFieldDescription):
    """
      A field holding the result of an aggregation of one or more other 
      field values.
    """
    aggregatedFieldName = str()
    statisticType = esriDataStatType.esriDataStatTypeCount
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAnnotationLayer(CIMBasicFeatureLayer):
    """
      Represents an annotation layer used to draw annotation feature 
      classes.
    """
    barrierWeight = BarrierWeight.High
    drawGeometry = False
    drawUnplacedAnnotation = False
    drawGeometryLineSymbol = 'CIMSymbolReference'
    drawGeometryPointSymbol = 'CIMSymbolReference'
    unplacedAnnotationColor = 'CIMColor'
    symbolSubstitutionType = SymbolSubstitutionType.eNone
    massColorSubstitute = 'CIMColor'
    inlineColor = 'CIMColor'
    substitutionSymbolCollection = []
    subLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAttachmentsMediaInfo(CIMMediaInfo):
    """
      Represents attachment media info.
    """
    caption = str()
    title = str()
    contentType = str()
    displayType = AttachmentDisplayType.PreviewFirst
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMAttributeCondition(CIMCondition):
    """
      Represents an attribute condition.
    """
    whereClause = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBasicFeatureTemplate(CIMEditingTemplate):
    """
      Represents a basic feature template.
    """
    defaultValues = {}
    requiredFields = []
    hiddenFields = []
    relationships = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBinningFeatureReduction(CIMFeatureReduction):
    """
      Represents a technique for reducing features by aggregating them 
      into polygon bins.
    """
    thresholdType = BinsToPointsThresholdType.MaxScale
    maximumScale = 500000
    featureCount = 1000
    minimumBinSize = 16
    fields = []
    visualization = 'CIMBinningVisualization'
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    fixedLevel = -1
    binType = esriFeatureBinType.esriFeatureBinTypeGeohexFlat
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMChartMediaInfo(CIMMediaInfo):
    """
      Represents chart media info.
    """
    fields = []
    normalizeField = str()
    caption = str()
    title = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColumnChartMediaInfo(CIMChartMediaInfo):
    """
      Represents column chart media info.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDimensionLayer(CIMBasicFeatureLayer):
    """
      Represents an dimension layer used to draw dimension feature classes.
    """
    barrierWeight = BarrierWeight.High
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDiscreteVariable(CIMBindVariable):
    """
      Represents a single bind variable.
    """
    defaultValue = list()
    boundValue = list()
    allowMultiple = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureDatasetDataConnection(CIMDataConnection):
    """
      Represents a feature dataset data connection.
    """
    featureDataset = str()
    """
      Represents a feature dataset data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureTable(CIMDisplayTable):
    """
      Represents a feature table.
    """
    dataConnection = 'CIMDataConnection'
    studyArea = GetPythonClass('arcpy', 'Extent')
    studyAreaSpatialRel = esriSpatialRelEnum.esriSpatialRelUndefined
    searchOrder = esriSearchOrder.esriSearchOrderSpatial
    isLicensedDataSource = False
    definitionSetURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureTemplate(CIMBasicFeatureTemplate):
    """
      Represents a feature template.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeoFeatureLayerBase(CIMBasicFeatureLayer):
    """
      Represents geographic feature layer base, a base class for geographic 
      feature layers.
    """
    actions = []
    exclusionSet = []
    featureMasks = []
    labelClasses = []
    labelVisibility = False
    maskedSymbolLayers = []
    mostCurrentRenderer = 'CIMRenderer'
    renderer = 'CIMRenderer'
    scaleSymbols = True
    snappable = True
    symbolLayerDrawing = 'CIMSymbolLayerDrawing'
    trackLinesRenderer = 'CIMRenderer'
    previousObservationsRenderer = 'CIMRenderer'
    previousObservationsCount = 0
    useRealWorldSymbolSizes = False
    showPreviousObservations = False
    featureReduction = 'CIMFeatureReduction'
    showTracks = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupEditingTemplate(CIMEditingTemplate):
    """
      Represents a group editing template.
    """
    baseName = str()
    basePart = 'CIMGroupEditingTemplatePart'
    parts = []
    createUtilityNetworkAssociations = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHighlightActivity(CIMActivity):
    """
      Represents a highlight activity.
    """
    highlightSymbol = 'CIMSymbolReference'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMImageMediaInfo(CIMMediaInfo):
    """
      Represents image media info.
    """
    sourceURL = str()
    linkURL = str()
    caption = str()
    title = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLineChartMediaInfo(CIMChartMediaInfo):
    """
      Represents line chart media info.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLocationCondition(CIMCondition):
    """
      Represents a location condition.
    """
    conditionType = LocationConditionType.In
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultipatchFeatureTemplate(CIMBasicFeatureTemplate):
    """
      Represents a multipatch feature template.
    """
    galleryMode = False
    models = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNetCDFRasterDataConnection(CIMDataConnection):
    """
      Represents a NetCDF raster data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a NetCDF raster data connection.
    """
    bandDimension = str()
    extent = GetPythonClass('arcpy', 'Extent')
    invertRows = False
    selectedDimensionIndexes = []
    selectedDimensions = []
    selectedDimensionValues = list()
    variable = str()
    verticalDimension = str()
    verticalDimensionUnit = str()
    xDimension = str()
    yDimension = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMNetCDFStandardDataConnection(CIMDataConnection):
    """
      Represents a NetCDF standard data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a NetCDF standard data connection.
    """
    variableList = []
    rowDimensionList = []
    xDimension = str()
    yDimension = str()
    zDimension = str()
    mDimension = str()
    selectedDimensions = []
    selectedDimensionIndexes = []
    selectedDimensionValues = list()
    shapeFieldName = str()
    verticalDimension = str()
    verticalDimensionUnit = str()
    selectedVolume = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPieChartMediaInfo(CIMChartMediaInfo):
    """
      Represents pie chart media info.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRangeVariable(CIMBindVariable):
    """
      Represents a range variable.
    """
    fieldExpression = str()
    optional = False
    defaultMin = object()
    defaultMax = object()
    tableName = str()
    valueIfMissing = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRasterTable(CIMDisplayTable):
    """
      Represents a raster table.
    """
    joins = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRelQueryTableDataConnection(CIMDataConnection):
    """
      Represents a RelQuery table data connection.
    """
    sourceTable = 'CIMDataConnection'
    destinationTable = 'CIMDataConnection'
    primaryKey = str()
    foreignKey = str()
    name = str()
    cardinality = esriRelCardinality.esriRelCardinalityManyToMany
    joinType = esriJoinType.esriLeftOuterJoin
    joinForward = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRelateInfo(CIMRelateInfoBase):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRouteEventDataConnection(CIMDataConnection):
    """
      Represents a route event data connection.
    """
    routeFeatureClass = 'CIMDataConnection'
    routeIDFieldName = str()
    routeWhereClause = str()
    routeMeasureUnit = str()
    eventMeasureUnit = str()
    eventRouteIDFieldName = str()
    isLineEvent = False
    lateralOffsetFieldName = str()
    mDirectionOffsetting = False
    errorFieldName = str()
    addErrorField = False
    fromMeasureFieldName = str()
    toMeasureFieldName = str()
    addAngleField = False
    angleFieldName = str()
    asPointFeature = False
    complementAngle = False
    normalAngle = False
    eventTable = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSqlQueryDataConnection(CIMDataConnection):
    """
      Represents a SQL query data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a SQL query data connection.
    """
    sqlQuery = str()
    srid = str()
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    oIDFields = str()
    geometryType = esriGeometryType.esriGeometryNull
    extent = GetPythonClass('arcpy', 'Extent')
    queryFields = list()
    spatialStorageType = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardDataConnection(CIMDataConnection):
    """
      Represents a standard data connection, the most common data connection 
      type.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStreamServiceDataConnection(CIMDataConnection):
    """
      Represents a stream service data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a stream service data connection.
    """
    featureExpirationMethod = FeatureExpirationMethod.MaximumFeatureCount
    maximumFeatureCount = 10000
    maximumFeatureAge = 3600
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubtypeGroupLayer(CIMBasicFeatureLayer):
    """
      Represents a subtype group layer that works with feature classes 
      enabled with subtypes.
    """
    subtypeLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubtypeGroupLayerBase(CIMBasicFeatureLayer):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSuppressActivity(CIMActivity):
    """
      Represents suppress activity.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableMediaInfo(CIMMediaInfo):
    """
      Represents table media info.
    """
    fields = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTableQueryNameDataConnection(CIMDataConnection):
    """
      Represents a table query name data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a table query name data connection.
    """
    subFields = str()
    tables = str()
    whereClause = str()
    primaryKeyFields = str()
    copyLocally = False
    shapeType = esriGeometryType.esriGeometryNull
    featureType = esriFeatureType.esriFTSimple
    extent = GetPythonClass('arcpy', 'Extent')
    shapeFieldName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTemporalDataConnection(CIMDataConnection):
    """
      Represents a temporal data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a temporal data connection.
    """
    timeFieldLocaleID = 0
    timeFieldAmFormat = str()
    timeFieldPmFormat = str()
    cachingMode = TemporalFeatureClassCachingMode.All
    startTimeField = str()
    endTimeField = str()
    timeValueFormat = str()
    trackIDField = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTextMediaInfo(CIMMediaInfo):
    """
      Represents text media info.
    """
    text = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTrackingServerDataConnection(CIMDataConnection):
    """
      Represents a tracking server data connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    dataset = str()
    datasetType = esriDatasetType.esriDTAny
    """
      Represents a tracking server data connection.
    """
    autoPurge = True
    purgeThreshold = 5000
    purgePercentage = 0.2
    keepPerTrack = 1
    purgeRule = TemporalFeatureClassPurgeRule.PurgeOldest
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMVectorTileDataConnection(CIMDataConnection):
    """
      Represents a VectorTile layer data connection.
    """
    uRI = str()
    resourcesURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMWorkspaceConnection(CIMDataConnection):
    """
      Represents a workspace connection.
    """
    workspaceConnectionString = str()
    workspaceFactory = WorkspaceFactory.SDE
    customWorkspaceFactoryCLSID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMXYEventDataConnection(CIMDataConnection):
    """
      Represents an XY event data connection.
    """
    xFieldName = str()
    yFieldName = str()
    zFieldName = str()
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    xYEventTableDataConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMBarChartMediaInfo(CIMChartMediaInfo):
    """
      Represents bar chart media info.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFeatureLayer(CIMGeoFeatureLayerBase):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeometryLocationCondition(CIMLocationCondition):
    """
      Represents geometry location condition.
    """
    geometries = list()
    def __init__(self, *args, **Kwargs):
        pass
    
