# -*- coding: utf-8 -*-
# COPYRIGHT 2019 ESRI
#
# TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
# Unpublished material - all rights reserved under the
# Copyright Laws of the United States.
#
# For additional information, contact:
# Environmental Systems Research Institute, Inc.
# Attn: Contracts Dept
# 380 New York Street
# Redlands, California, USA 92373
#
# email: contracts@esri.com
#
# Warning: This module is automatically generated, changes will be overwritten.
from arcgisscripting import _wrapToolRaster, _wrapLocalFunctionRaster
import arcpy
from ..sa import ParameterClasses
from ..sa import Utils

try:
    unicode
except NameError:
    unicode = str


__all__ = [
    "Abs",
    "Divide",
    "Exp",
    "Exp10",
    "Exp2",
    "Float",
    "Int",
    "Ln",
    "Log10",
    "Log2",
    "Minus",
    "Mod",
    "Negate",
    "Plus",
    "Power",
    "RoundDown",
    "RoundUp",
    "Square",
    "SquareRoot",
    "Times",
    "Con",
    "Pick",
    "SetNull",
    "BitwiseAnd",
    "BitwiseLeftShift",
    "BitwiseNot",
    "BitwiseOr",
    "BitwiseRightShift",
    "BitwiseXOr",
    "BooleanAnd",
    "BooleanNot",
    "BooleanOr",
    "BooleanXOr",
    "CombinatorialAnd",
    "CombinatorialOr",
    "CombinatorialXOr",
    "Diff",
    "EqualTo",
    "GreaterThan",
    "GreaterThanEqual",
    "InList",
    "IsNull",
    "LessThan",
    "LessThanEqual",
    "NotEqual",
    "Over",
    "Test",
    "ACos",
    "ACosH",
    "ASin",
    "ASinH",
    "ATan",
    "ATan2",
    "ATanH",
    "Cos",
    "CosH",
    "Sin",
    "SinH",
    "Tan",
    "TanH",
    "WeightedSum",
    "ClassifyRaster",
    "ComputeConfusionMatrix",
    "ComputeSegmentAttributes",
    "CreateAccuracyAssessmentPoints",
    "ExportTrainingDataForDeepLearning",
    "GenerateTrainingSamplesFromSeedPoints",
    "InspectTrainingSamples",
    "RemoveRasterSegmentTilingArtifacts",
    "SegmentMeanShift",
    "TrainIsoClusterClassifier",
    "TrainMaximumLikelihoodClassifier",
    "TrainRandomTreesClassifier",
    "TrainSupportVectorMachineClassifier",
    "UpdateAccuracyAssessmentPoints",
    "CellStatistics",
    "FocalStatistics",
    "ZonalStatistics",
    "VideoMultiplexer",
    "ClassifyPixelsUsingDeepLearning",
    "DetectObjectsUsingDeepLearning",
    "NonMaximumSuppression",
    "VideoMetadataToFeatureClass",
    "ExtractVideoFramesToImages",
    "AggregateMultidimensionalRaster",
    "GenerateMultidimensionalAnomaly",
    "GenerateTrendRaster",
    "FindArgumentStatistics",
    "PredictUsingTrendRaster",
    "LinearSpectralUnmixing",
    "ClassifyObjectsUsingDeepLearning",
    "TrainDeepLearningModel",
    "ApplyEnvironment",
    "FloatDivide",
    "FloorDivide"
]


def Abs(
        in_raster_or_constant):
    """Abs(in_raster_or_constant)

    Calculates the absolute value of the cells in a raster.

    Arguments:
    in_raster_or_constant -- The input raster for which to calculate the absolute values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Abs_sa",
            ["Abs", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Abs.__esri_toolname__ = "Abs_ia"
Abs.__esri_toolinfo__ = [
    "::::1"
]


def Divide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Divide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["Divide", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Divide.__esri_toolname__ = "Divide_ia"
Divide.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Exp(
        in_raster_or_constant):
    """Exp(in_raster_or_constant)

    Calculates the base e exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- The input values for which to find the base e exponential.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp_sa",
            ["Exp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp.__esri_toolname__ = "Exp_ia"
Exp.__esri_toolinfo__ = [
    "::::1"
]


def Exp10(
        in_raster_or_constant):
    """Exp10(in_raster_or_constant)

    Calculates the base 10 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- The input values for which to find the base 10 exponential.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp10_sa",
            ["Exp10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp10.__esri_toolname__ = "Exp10_ia"
Exp10.__esri_toolinfo__ = [
    "::::1"
]


def Exp2(
        in_raster_or_constant):
    """Exp2(in_raster_or_constant)

    Calculates the base 2 exponential of the cells in a raster.

    Arguments:
    in_raster_or_constant -- The input values for which to find the base 2 exponential.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Exp2_sa",
            ["Exp2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Exp2.__esri_toolname__ = "Exp2_ia"
Exp2.__esri_toolinfo__ = [
    "::::1"
]


def Float(
        in_raster_or_constant):
    """Float(in_raster_or_constant)

    Converts each cell value of a raster into a floating-point representation.

    Arguments:
    in_raster_or_constant -- The input raster to be converted to floating point.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Float_sa",
            ["Float", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Float.__esri_toolname__ = "Float_ia"
Float.__esri_toolinfo__ = [
    "::::1"
]


def Int(
        in_raster_or_constant):
    """Int(in_raster_or_constant)

    Converts each cell value of a raster to an integer by truncation.

    Arguments:
    in_raster_or_constant -- The input raster to be converted to integer.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Int_sa",
            ["Int", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Int.__esri_toolname__ = "Int_ia"
Int.__esri_toolinfo__ = [
    "::::1"
]


def Ln(
        in_raster_or_constant):
    """Ln(in_raster_or_constant)

    Calculates the natural logarithm (base e) of cells in a raster.

    Arguments:
    in_raster_or_constant -- Input values for which to find the natural logarithm (Ln).

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Ln_sa",
            ["Ln", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Ln.__esri_toolname__ = "Ln_ia"
Ln.__esri_toolinfo__ = [
    "::::1"
]


def Log10(
        in_raster_or_constant):
    """Log10(in_raster_or_constant)

    Calculates the base 10 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- Input values for which to find the base 10 logarithm.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log10_sa",
            ["Log10", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log10.__esri_toolname__ = "Log10_ia"
Log10.__esri_toolinfo__ = [
    "::::1"
]


def Log2(
        in_raster_or_constant):
    """Log2(in_raster_or_constant)

    Calculates the base 2 logarithm of cells in a raster.

    Arguments:
    in_raster_or_constant -- Input values for which to find the base 2 logarithm.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Log2_sa",
            ["Log2", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Log2.__esri_toolname__ = "Log2_ia"
Log2.__esri_toolinfo__ = [
    "::::1"
]


def Minus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Minus(in_raster_or_constant1, in_raster_or_constant2)

    Subtracts the value of the second input raster from the value of the first input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input from which to subtract the values in the second input.
    in_raster_or_constant2 -- The input values to subtract from the values in the first input.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Minus_sa",
            ["Minus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Minus.__esri_toolname__ = "Minus_ia"
Minus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Mod(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Mod(in_raster_or_constant1, in_raster_or_constant2)

    Finds the remainder (modulo) of the first raster when divided by the second raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The numerator input.
    in_raster_or_constant2 -- The denominator input.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Mod_sa",
            ["Mod", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Mod.__esri_toolname__ = "Mod_ia"
Mod.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Negate(
        in_raster_or_constant):
    """Negate(in_raster_or_constant)

    Changes the sign (multiplies by -1) of the cell values of the input raster on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- The input raster to be negated (multiplied by -1).

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Negate_sa",
            ["Negate", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Negate.__esri_toolname__ = "Negate_ia"
Negate.__esri_toolinfo__ = [
    "::::1"
]


def Plus(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Plus(in_raster_or_constant1, in_raster_or_constant2)

    Adds (sums) the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be added to.
    in_raster_or_constant2 -- The input whose values will be added to the first input.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Plus_sa",
            ["Plus", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Plus.__esri_toolname__ = "Plus_ia"
Plus.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Power(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Power(in_raster_or_constant1, in_raster_or_constant2)

    Raises the cell values in a raster to the power of the values found in another raster.

    Arguments:
    in_raster_or_constant1 -- The input values to be raised to the power defined by the second input.
    in_raster_or_constant2 -- The input that determines the power the values in the first input will be raised to.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Power_sa",
            ["Power", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Power.__esri_toolname__ = "Power_ia"
Power.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def RoundDown(
        in_raster_or_constant):
    """RoundDown(in_raster_or_constant)

    Returns the next lower integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- The input values to be rounded down.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundDown_sa",
            ["RoundDown", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundDown.__esri_toolname__ = "RoundDown_ia"
RoundDown.__esri_toolinfo__ = [
    "::::1"
]


def RoundUp(
        in_raster_or_constant):
    """RoundUp(in_raster_or_constant)

    Returns the next higher integer value, just represented as a floating point, for each cell in a raster.

    Arguments:
    in_raster_or_constant -- The input values to be rounded up.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"RoundUp_sa",
            ["RoundUp", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
RoundUp.__esri_toolname__ = "RoundUp_ia"
RoundUp.__esri_toolinfo__ = [
    "::::1"
]


def Square(
        in_raster_or_constant):
    """Square(in_raster_or_constant)

    Calculates the square of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- The input values to find the square of.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Square_sa",
            ["Square", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Square.__esri_toolname__ = "Square_ia"
Square.__esri_toolinfo__ = [
    "::::1"
]


def SquareRoot(
        in_raster_or_constant):
    """SquareRoot(in_raster_or_constant)

    Calculates the square root of the cell values in a raster.

    Arguments:
    in_raster_or_constant -- The input values to find the square root of.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SquareRoot_sa",
            ["SquareRoot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SquareRoot.__esri_toolname__ = "SquareRoot_ia"
SquareRoot.__esri_toolinfo__ = [
    "::::1"
]


def Times(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Times(in_raster_or_constant1, in_raster_or_constant2)

    Multiplies the values of two rasters on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input containing the values to be multiplied.
    in_raster_or_constant2 -- The input containing the values by which the first input will be multiplied.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Times_sa",
            ["Times", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Times.__esri_toolname__ = "Times_ia"
Times.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Con(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant="#",
        where_clause="#"):
    """Con(in_conditional_raster, in_true_raster_or_constant, {in_false_raster_or_constant}, {where_clause})

    Performs a conditional if/else evaluation on each of the input cells of an input raster.

    Arguments:
    in_conditional_raster -- Input raster representing the true or false result of the desired condition.
    in_true_raster_or_constant -- The input whose values will be used as the output cell values if the condition is true.
    in_false_raster_or_constant -- The input whose values will be used as the output cell values if the condition is false.
    where_clause -- A logical expression that determines which of the input cells are to be true or false.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_true_raster_or_constant,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            if Utils.useDefaultArgumentValue(in_false_raster_or_constant):
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThen", in_conditional_raster, in_true_raster_or_constant])
            else:
                return _wrapLocalFunctionRaster(u"Con_sa",
                    ["IfThenElse", in_conditional_raster, in_true_raster_or_constant, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.Con_ia(
            in_conditional_raster,
            in_true_raster_or_constant,
            out_raster,
            in_false_raster_or_constant,
            where_clause)
        return _wrapToolRaster(u"Con_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_true_raster_or_constant,
        in_false_raster_or_constant,
        where_clause)
Con.__esri_toolname__ = "Con_ia"
Con.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5"
]


def Pick(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband="#"):
    """Pick(in_position_raster, [in_raster_or_constant,...], {process_as_multiband})

    The value from a position raster is used to determine from which raster in a list of input rasters the output cell value will be obtained.

    Arguments:
    in_position_raster -- Input raster defining the position of the raster to use for the output value.
    in_raster_or_constant -- The list of inputs from which the output value will be selected.
    process_as_multiband -- Specifies how the input multiband raster bands are processed.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_position_raster,
            in_rasters_or_constants,
            process_as_multiband):
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (Pick). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        return _wrapLocalFunctionRaster(u"Pick_ia", ["Pick", in_position_raster] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_position_raster,
        in_rasters_or_constants,
        process_as_multiband)
Pick.__esri_toolname__ = "Pick_ia"
Pick.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def SetNull(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause="#"):
    """SetNull(in_conditional_raster, in_false_raster_or_constant, {where_clause})

    Set Null sets identified cell locations to NoData based on a specified criteria. It returns NoData if a conditional evaluation is true, and returns the value specified by another raster if it is false.

    Arguments:
    in_conditional_raster -- Input raster representing the true or false result of the desired condition.
    in_false_raster_or_constant -- The input whose values will be used as the output cell values if the condition is false.
    where_clause -- A logical expression that determines which of the input cells are to be true or false.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_conditional_raster,
            in_false_raster_or_constant,
            where_clause):
        if Utils.useDefaultArgumentValue(where_clause):
            return _wrapLocalFunctionRaster(u"SetNull_sa",
                ["SetNull", in_conditional_raster, in_false_raster_or_constant])
        out_raster = "#"
        result = arcpy.gp.SetNull_ia(
            in_conditional_raster,
            in_false_raster_or_constant,
            out_raster,
            where_clause)
        return _wrapToolRaster(u"SetNull_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_conditional_raster,
        in_false_raster_or_constant,
        where_clause)
SetNull.__esri_toolname__ = "SetNull_ia"
SetNull.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def BitwiseAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseAnd(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise And operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this bitwise operation.
    in_raster_or_constant2 -- The second input to use in this bitwise operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseAnd_sa",
            ["BitwiseAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseAnd.__esri_toolname__ = "BitwiseAnd_ia"
BitwiseAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseLeftShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseLeftShift(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Left Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The input on which to perform the shift.
    in_raster_or_constant2 -- The input defining the number of positions to shift the bits.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseLeftShift_sa",
            ["BitwiseLeftShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseLeftShift.__esri_toolname__ = "BitwiseLeftShift_ia"
BitwiseLeftShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseNot(
        in_raster_or_constant):
    """BitwiseNot(in_raster_or_constant)

    Performs a Bitwise Not (complement) operation on the binary value of an input raster.

    Arguments:
    in_raster_or_constant -- The input raster on which to perform the Bitwise Not (complement) operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BitwiseNot_sa",
            ["BitwiseNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BitwiseNot.__esri_toolname__ = "BitwiseNot_ia"
BitwiseNot.__esri_toolinfo__ = [
    "::::1"
]


def BitwiseOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this bitwise operation.
    in_raster_or_constant2 -- The second input to use in this bitwise operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseOr_sa",
            ["BitwiseOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseOr.__esri_toolname__ = "BitwiseOr_ia"
BitwiseOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseRightShift(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseRightShift(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise Right Shift operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The input on which to perform the shift.
    in_raster_or_constant2 -- The input defining the number of positions to shift the bits.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseRightShift_sa",
            ["BitwiseRightShift", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseRightShift.__esri_toolname__ = "BitwiseRightShift_ia"
BitwiseRightShift.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BitwiseXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BitwiseXOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Bitwise eXclusive Or operation on the binary values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this bitwise operation.
    in_raster_or_constant2 -- The second input to use in this bitwise operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BitwiseXOr_sa",
            ["BitwiseXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BitwiseXOr.__esri_toolname__ = "BitwiseXOr_ia"
BitwiseXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanAnd(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this Boolean operation.
    in_raster_or_constant2 -- The second input to use in this Boolean operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanAnd_sa",
            ["BooleanAnd", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanAnd.__esri_toolname__ = "BooleanAnd_ia"
BooleanAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanNot(
        in_raster_or_constant):
    """BooleanNot(in_raster_or_constant)

    Performs a Boolean Not (complement) operation on the cell values of the input raster.

    Arguments:
    in_raster_or_constant -- The input to use in this Boolean operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"BooleanNot_sa",
            ["BooleanNot", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
BooleanNot.__esri_toolname__ = "BooleanNot_ia"
BooleanNot.__esri_toolinfo__ = [
    "::::1"
]


def BooleanOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this Boolean operation.
    in_raster_or_constant2 -- The second input to use in this Boolean operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanOr_sa",
            ["BooleanOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanOr.__esri_toolname__ = "BooleanOr_ia"
BooleanOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def BooleanXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """BooleanXOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Boolean eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this Boolean operation.
    in_raster_or_constant2 -- The second input to use in this Boolean operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"BooleanXOr_sa",
            ["BooleanXOr", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
BooleanXOr.__esri_toolname__ = "BooleanXOr_ia"
BooleanXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialAnd(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialAnd(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial And operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this combinatorial operation.
    in_raster_or_constant2 -- The second input to use in this combinatorial operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialAnd_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialAnd_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialAnd.__esri_toolname__ = "CombinatorialAnd_ia"
CombinatorialAnd.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this combinatorial operation.
    in_raster_or_constant2 -- The second input to use in this combinatorial operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialOr_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialOr.__esri_toolname__ = "CombinatorialOr_ia"
CombinatorialOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def CombinatorialXOr(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """CombinatorialXOr(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Combinatorial eXclusive Or operation on the cell values of two input rasters.

    Arguments:
    in_raster_or_constant1 -- The first input to use in this combinatorial operation.
    in_raster_or_constant2 -- The second input to use in this combinatorial operation.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        out_raster = "#"
        result = arcpy.gp.CombinatorialXOr_ia(
            in_raster_or_constant1,
            in_raster_or_constant2,
            out_raster)
        return _wrapToolRaster(u"CombinatorialXOr_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
CombinatorialXOr.__esri_toolname__ = "CombinatorialXOr_ia"
CombinatorialXOr.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Diff(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Diff(in_raster_or_constant1, in_raster_or_constant2)

    Determines which values from the first input are logically different from the values of the second input on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input to which the second input will be compared.
    in_raster_or_constant2 -- The input to which the first input will be compared.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Diff_sa",
            ["Diff", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Diff.__esri_toolname__ = "Diff_ia"
Diff.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def EqualTo(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """EqualTo(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input that will be compared to for equality by the second input.
    in_raster_or_constant2 -- The input that will be compared from for equality by the first input.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"EqualTo_sa",
            ["EqualTo", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
EqualTo.__esri_toolname__ = "EqualTo_ia"
EqualTo.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def GreaterThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThan(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input being tested to determine if it is greater than the second input.
    in_raster_or_constant2 -- The input against which the first input is tested to be greater than.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThan_sa",
            ["GreaterThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThan.__esri_toolname__ = "GreaterThan_ia"
GreaterThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def GreaterThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """GreaterThanEqual(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational greater-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input being tested to determine if it is greater than or equal to the second input.
    in_raster_or_constant2 -- The input against which the first input is tested to be greater than or equal to.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"GreaterThanEqual_sa",
            ["GreaterThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
GreaterThanEqual.__esri_toolname__ = "GreaterThanEqual_ia"
GreaterThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def InList(
        in_raster_or_constant,
        in_raster_or_constants):
    """InList(in_raster_or_constant, [in_raster_or_constant,...])

    Determines which values from the first input are contained in a set of other inputs, on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant -- The input raster whose values will be looked for in the input list.
    in_raster_or_constant -- A list of input rasters in which the cell values from the first input will be looked for.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant,
            in_raster_or_constants):
        return _wrapLocalFunctionRaster(u"InList_ia", ["InList", in_raster_or_constant] + Utils.flattenLists(in_raster_or_constants))
    return Wrapper(
        in_raster_or_constant,
        in_raster_or_constants)
InList.__esri_toolname__ = "InList_ia"
InList.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def IsNull(
        in_raster):
    """IsNull(in_raster)

    Determines which values from the input raster are NoData on a cell-by-cell basis.

    Arguments:
    in_raster -- The input raster being tested to identify the cells that are NoData (null).

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster):
        return _wrapLocalFunctionRaster(u"IsNull_sa",
            ["IsNull", in_raster])
    return Wrapper(
        in_raster)
IsNull.__esri_toolname__ = "IsNull_ia"
IsNull.__esri_toolinfo__ = [
    "::::1"
]


def LessThan(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThan(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input being tested to determine if it is less than the second input.
    in_raster_or_constant2 -- The input against which the first input is tested to be less than.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThan_sa",
            ["LessThan", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThan.__esri_toolname__ = "LessThan_ia"
LessThan.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def LessThanEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """LessThanEqual(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational less-than-or-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input being tested to determine if it is less than or equal to the second input.
    in_raster_or_constant2 -- The input against which the first input is tested to be less than or equal to.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"LessThanEqual_sa",
            ["LessThanEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
LessThanEqual.__esri_toolname__ = "LessThanEqual_ia"
LessThanEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def NotEqual(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """NotEqual(in_raster_or_constant1, in_raster_or_constant2)

    Performs a Relational not-equal-to operation on two inputs on a cell-by-cell basis.

    Arguments:
    in_raster_or_constant1 -- The input that will be compared to for inequality by the second input.
    in_raster_or_constant2 -- The input that will be compared from for inequality by the first input.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"NotEqual_sa",
            ["NotEqual", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
NotEqual.__esri_toolname__ = "NotEqual_ia"
NotEqual.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Over(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """Over(in_raster_or_constant1, in_raster_or_constant2)

    For the cell values in the first input that are not 0, the output value will be that of the first input. Where the cell values are 0, the output will be that of the second input raster.

    Arguments:
    in_raster_or_constant1 -- The input for which cell values of 0 will be replaced with the value from the second input.
    in_raster_or_constant2 -- The input whose value will be assigned to the output raster cells where the first input value is 0.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Over_sa",
            ["Over", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
Over.__esri_toolname__ = "Over_ia"
Over.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def Test(
        in_raster,
        where_clause):
    """Test(in_raster, where_clause)

    Performs a Boolean evaluation of the input raster using a logical expression.

    Arguments:
    in_raster -- The input raster on which the Boolean evaluation is performed, based on a logical expression.
    where_clause -- The logical expression that will determine which input cells will return a value of true (1) and which will be false (0).

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            where_clause):
        out_raster = "#"
        result = arcpy.gp.Test_ia(
            in_raster,
            where_clause,
            out_raster)
        return _wrapToolRaster(u"Test_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        where_clause)
Test.__esri_toolname__ = "Test_ia"
Test.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ACos(
        in_raster_or_constant):
    """ACos(in_raster_or_constant)

    Calculates the inverse cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse cosine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACos_sa",
            ["ACos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACos.__esri_toolname__ = "ACos_ia"
ACos.__esri_toolinfo__ = [
    "::::1"
]


def ACosH(
        in_raster_or_constant):
    """ACosH(in_raster_or_constant)

    Calculates the inverse hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse hyperbolic cosine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ACosH_sa",
            ["ACosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ACosH.__esri_toolname__ = "ACosH_ia"
ACosH.__esri_toolinfo__ = [
    "::::1"
]


def ASin(
        in_raster_or_constant):
    """ASin(in_raster_or_constant)

    Calculates the inverse sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse sine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASin_sa",
            ["ASin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASin.__esri_toolname__ = "ASin_ia"
ASin.__esri_toolinfo__ = [
    "::::1"
]


def ASinH(
        in_raster_or_constant):
    """ASinH(in_raster_or_constant)

    Calculates the inverse hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse hyperbolic sine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ASinH_sa",
            ["ASinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ASinH.__esri_toolname__ = "ASinH_ia"
ASinH.__esri_toolinfo__ = [
    "::::1"
]


def ATan(
        in_raster_or_constant):
    """ATan(in_raster_or_constant)

    Calculates the inverse tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse tangent values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATan_sa",
            ["ATan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATan.__esri_toolname__ = "ATan_ia"
ATan.__esri_toolinfo__ = [
    "::::1"
]


def ATan2(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """ATan2(in_raster_or_constant1, in_raster_or_constant2)

    Calculates the inverse tangent (based on x,y) of cells in a raster.

    Arguments:
    in_raster_or_constant1 -- The input that specifies the numerator, or y value, to use when calculating the inverse tangent.
    in_raster_or_constant2 -- The input that specifies the denominator, or x value, to use when calculating the inverse tangent.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"ATan2_sa",
            ["ATan2", in_raster_or_constant1, in_raster_or_constant2])
    return Wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)
ATan2.__esri_toolname__ = "ATan2_ia"
ATan2.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ATanH(
        in_raster_or_constant):
    """ATanH(in_raster_or_constant)

    Calculates the inverse hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the inverse hyperbolic tangent values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"ATanH_sa",
            ["ATanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
ATanH.__esri_toolname__ = "ATanH_ia"
ATanH.__esri_toolinfo__ = [
    "::::1"
]


def Cos(
        in_raster_or_constant):
    """Cos(in_raster_or_constant)

    Calculates the cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the cosine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Cos_sa",
            ["Cos", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Cos.__esri_toolname__ = "Cos_ia"
Cos.__esri_toolinfo__ = [
    "::::1"
]


def CosH(
        in_raster_or_constant):
    """CosH(in_raster_or_constant)

    Calculates the hyperbolic cosine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the hyperbolic cosine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"CosH_sa",
            ["CosH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
CosH.__esri_toolname__ = "CosH_ia"
CosH.__esri_toolinfo__ = [
    "::::1"
]


def Sin(
        in_raster_or_constant):
    """Sin(in_raster_or_constant)

    Calculates the sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the sine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Sin_sa",
            ["Sin", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Sin.__esri_toolname__ = "Sin_ia"
Sin.__esri_toolinfo__ = [
    "::::1"
]


def SinH(
        in_raster_or_constant):
    """SinH(in_raster_or_constant)

    Calculates the hyperbolic sine of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the hyperbolic sine values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"SinH_sa",
            ["SinH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
SinH.__esri_toolname__ = "SinH_ia"
SinH.__esri_toolinfo__ = [
    "::::1"
]


def Tan(
        in_raster_or_constant):
    """Tan(in_raster_or_constant)

    Calculates the tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input for which to calculate the tangent values.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"Tan_sa",
            ["Tan", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
Tan.__esri_toolname__ = "Tan_ia"
Tan.__esri_toolinfo__ = [
    "::::1"
]


def TanH(
        in_raster_or_constant):
    """TanH(in_raster_or_constant)

    Calculates the hyperbolic tangent of cells in a raster.

    Arguments:
    in_raster_or_constant -- The input to calculate the hyperbolic tangent values for.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster_or_constant):
        return _wrapLocalFunctionRaster(u"TanH_sa",
            ["TanH", in_raster_or_constant])
    return Wrapper(
        in_raster_or_constant)
TanH.__esri_toolname__ = "TanH_ia"
TanH.__esri_toolinfo__ = [
    "::::1"
]


def WeightedSum(
        in_weighted_sum_table):
    """WeightedSum(in_weighted_sum_table)

    Overlays several rasters, multiplying each by their given weight and summing them together.

    Arguments:
    in_weighted_sum_table -- TheWeighted Sum tool overlays several rasters, multiplying each by their given weight and summing them together.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_weighted_sum_table):
        in_weighted_sum_table = Utils.compoundParameterToString(in_weighted_sum_table, ParameterClasses.WSTable)
        out_raster = "#"
        result = arcpy.gp.WeightedSum_ia(
            in_weighted_sum_table,
            out_raster)
        return _wrapToolRaster(u"WeightedSum_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_weighted_sum_table)
WeightedSum.__esri_toolname__ = "WeightedSum_ia"
WeightedSum.__esri_toolinfo__ = [
    "Python::WSTable::"
]


def ClassifyRaster(
        in_raster,
        in_classifier_definition,
        in_additional_raster="#"):
    """ClassifyRaster(in_raster, in_classifier_definition, {in_additional_raster})

    Classifies a raster dataset based on an Esri classifier definition file (.ecd) and raster dataset inputs.

    Arguments:
    in_raster -- The raster dataset to classify.
    in_classifier_definition -- The input Esri classifier definition file (.ecd) containing the statistics for the chosen attributes for the classifier.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for the classifier. This raster will be necessary when calculating attributes such as mean or standard deviation. This parameter is optional.

    Results:
    out_raster_dataset -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_classifier_definition,
            in_additional_raster):
        out_raster_dataset = "#"
        result = arcpy.gp.ClassifyRaster_ia(
            in_raster,
            in_classifier_definition,
            out_raster_dataset,
            in_additional_raster)
        return _wrapToolRaster(u"ClassifyRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_classifier_definition,
        in_additional_raster)
ClassifyRaster.__esri_toolname__ = "ClassifyRaster_ia"
ClassifyRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4"
]


def ComputeConfusionMatrix(
        in_accuracy_assessment_points,
        out_confusion_matrix):
    """ComputeConfusionMatrix(in_accuracy_assessment_points, out_confusion_matrix)

    Computes a confusion matrix with errors of omission and commission and derives a kappa index of agreement and an overall accuracy between the classified map and the reference data.

    Arguments:
    in_accuracy_assessment_points -- The accuracy assessment point feature class, created from the Create Accuracy Assessment Points tool, containing the CLASSIFIED and GROUND_TRUTH fields.
    out_confusion_matrix -- The output file name of the confusion matrix in table format."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_accuracy_assessment_points,
            out_confusion_matrix):
        result = arcpy.gp.ComputeConfusionMatrix_ia(
            in_accuracy_assessment_points,
            out_confusion_matrix)
        return result
    return Wrapper(
        in_accuracy_assessment_points,
        out_confusion_matrix)
ComputeConfusionMatrix.__esri_toolname__ = "ComputeConfusionMatrix_ia"
ComputeConfusionMatrix.__esri_toolinfo__ = [
    "::::1",
    "::::2"
]


def ComputeSegmentAttributes(
        in_segmented_raster,
        in_additional_raster="#",
        used_attributes="#"):
    """ComputeSegmentAttributes(in_segmented_raster, {in_additional_raster}, {[used_attributes,...]})

    Computes a set of attributes associated with the segmented image. The input raster can be a single-band or 3-band, 8-bit segmented image.

    Arguments:
    in_segmented_raster -- The input segmented raster dataset, where all the pixels belonging to a segment have the same converged RGB color. Usually, it is an 8-bit, 3-band RGB raster, but it can also be a 1-band grayscale raster.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for the classifier. This raster will be necessary when calculating attributes such as mean or standard deviation. This parameter is optional.
    used_attributes -- Specifies the attributes to be included in the attribute table associated with the output raster.

    Results:
    out_index_raster_dataset -- Output Segment Index Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            in_additional_raster,
            used_attributes):
        out_index_raster_dataset = "#"
        result = arcpy.gp.ComputeSegmentAttributes_ia(
            in_segmented_raster,
            out_index_raster_dataset,
            in_additional_raster,
            used_attributes)
        return _wrapToolRaster(u"ComputeSegmentAttributes_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        in_additional_raster,
        used_attributes)
ComputeSegmentAttributes.__esri_toolname__ = "ComputeSegmentAttributes_ia"
ComputeSegmentAttributes.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def CreateAccuracyAssessmentPoints(
        in_class_data,
        out_points,
        target_field="#",
        num_random_points="#",
        sampling="#"):
    """CreateAccuracyAssessmentPoints(in_class_data, out_points, {target_field}, {num_random_points}, {sampling})

    Creates randomly sampled points for post-classification accuracy assessment.

    Arguments:
    in_class_data -- The input classification image or other thematic GIS reference data. The input can be a raster or feature class.
    out_points -- The output point shapefile or feature class that contains the random points to be used for accuracy assessment.
    target_field -- Specifies whether the input data is a classified image or ground truth data.
    num_random_points -- The total number of random points that will be generated.
    sampling -- Specify a sampling scheme to use."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling):
        result = arcpy.gp.CreateAccuracyAssessmentPoints_ia(
            in_class_data,
            out_points,
            target_field,
            num_random_points,
            sampling)
        return result
    return Wrapper(
        in_class_data,
        out_points,
        target_field,
        num_random_points,
        sampling)
CreateAccuracyAssessmentPoints.__esri_toolname__ = "CreateAccuracyAssessmentPoints_ia"
CreateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def ExportTrainingDataForDeepLearning(
        in_raster,
        out_folder,
        in_class_data="#",
        image_chip_format="#",
        tile_size_x="#",
        tile_size_y="#",
        stride_x="#",
        stride_y="#",
        output_nofeature_tiles="#",
        metadata_format="#",
        start_index="#",
        class_value_field="#",
        buffer_radius="#",
        in_mask_polygons="#",
        rotation_angle="#",
        reference_system="#",
        processing_mode="#",
        blacken_around_feature="#",
        crop_mode="#"):
    """ExportTrainingDataForDeepLearning(in_raster, out_folder, {in_class_data}, {image_chip_format}, {tile_size_x}, {tile_size_y}, {stride_x}, {stride_y}, {output_nofeature_tiles}, {metadata_format}, {start_index}, {class_value_field}, {buffer_radius}, {in_mask_polygons}, {rotation_angle}, {reference_system}, {processing_mode}, {blacken_around_feature}, {crop_mode})

    Uses a remote sensing image to convert labeled vector or raster data into deep learning training datasets. The output is a folder of image chips and a folder of metadata files in the specified format.

    Arguments:
    in_raster -- The input source imagery, typically multispectral imagery.
    out_folder -- The folder where the output image chips and metadata will be stored.
    in_class_data -- The training sample data, in either vector or raster form.
    image_chip_format -- Specifies the raster format for the image chip outputs.
    tile_size_x -- The size of the image chips for the X dimension.
    tile_size_y -- The size of the image chips for the Y dimension.
    stride_x -- The distance to move in the X direction when creating the next image chips.
    stride_y -- The distance to move in the Y direction when creating the next image chips.
    output_nofeature_tiles -- Specifies whether image chips that do not capture training samples will be exported.
    metadata_format -- Specifies the format of the output metadata labels.
    start_index -- 
    class_value_field -- The field that contains the class values. If no field is specified, the system searches for a value or classvalue field. If the feature does not contain a class field, the system determines that all records belong to one class.
    buffer_radius -- The radius for a buffer around each training sample to delineate a training sample area. This allows you to create circular polygon training samples from points.
    in_mask_polygons -- A polygon feature class that delineates the area where image chips will be created.
    rotation_angle -- The rotation angle that will be used to generate additional image chips.
    reference_system -- Specifies
the type of reference system 
to be used to interpret the input image. The reference system specified should match the reference system used to train the deep learning model.
    processing_mode -- Specifies how 
all raster items in a mosaic dataset or an image service will be processed. This parameter is applied when the input raster is a mosaic dataset or an image service.
    blacken_around_feature -- Specifies whether to blacken the pixels around each object or feature in each image tile.
    crop_mode -- Specifies whether to crop the exported tiles such that they are all the same size."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode):
        result = arcpy.gp.ExportTrainingDataForDeepLearning_ia(
            in_raster,
            out_folder,
            in_class_data,
            image_chip_format,
            tile_size_x,
            tile_size_y,
            stride_x,
            stride_y,
            output_nofeature_tiles,
            metadata_format,
            start_index,
            class_value_field,
            buffer_radius,
            in_mask_polygons,
            rotation_angle,
            reference_system,
            processing_mode,
            blacken_around_feature,
            crop_mode)
        return result
    return Wrapper(
        in_raster,
        out_folder,
        in_class_data,
        image_chip_format,
        tile_size_x,
        tile_size_y,
        stride_x,
        stride_y,
        output_nofeature_tiles,
        metadata_format,
        start_index,
        class_value_field,
        buffer_radius,
        in_mask_polygons,
        rotation_angle,
        reference_system,
        processing_mode,
        blacken_around_feature,
        crop_mode)
ExportTrainingDataForDeepLearning.__esri_toolname__ = "ExportTrainingDataForDeepLearning_ia"
ExportTrainingDataForDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12",
    "::::13",
    "::::14",
    "::::15",
    "::::16",
    "::::17",
    "::::18",
    "::::19"
]


def GenerateTrainingSamplesFromSeedPoints(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area="#",
        max_sample_radius="#"):
    """GenerateTrainingSamplesFromSeedPoints(in_class_data, in_seed_points, out_training_feature_class, {min_sample_area}, {max_sample_radius})

    Generates training samples from seed points, such as accuracy assessment points or training sample points. A typical use case is generating training samples from an existing source, such as a thematic raster or a feature class.

    Arguments:
    in_class_data -- The data source that labels the training samples.
    in_seed_points -- A point shapefile or feature class to provide the centers of training sample polygons.
    out_training_feature_class -- The output training sample feature class in the format that can be used in training tools, including shapefiles. The output feature class can be either a polygon feature class or a point feature class.
    min_sample_area -- The minimum area needed for each training sample, in square meters. The minimum value must be greater than or equal to 0.
    max_sample_radius -- The longest distance (in meters) from any point within the training sample to its center seed point. If set to 0, the output training sample will be points instead of polygons. The minimum value must be greater than or equal to 0."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius):
        result = arcpy.gp.GenerateTrainingSamplesFromSeedPoints_ia(
            in_class_data,
            in_seed_points,
            out_training_feature_class,
            min_sample_area,
            max_sample_radius)
        return result
    return Wrapper(
        in_class_data,
        in_seed_points,
        out_training_feature_class,
        min_sample_area,
        max_sample_radius)
GenerateTrainingSamplesFromSeedPoints.__esri_toolname__ = "GenerateTrainingSamplesFromSeedPoints_ia"
GenerateTrainingSamplesFromSeedPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def InspectTrainingSamples(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster="#"):
    """InspectTrainingSamples(in_raster, in_training_features, in_classifier_definition, out_training_feature_class, {in_additional_raster})

    Estimates the accuracy of individual training samples. The cross validation accuracy is computed using the previously generated classification training result in an .ecd file and the training samples. Outputs include a raster dataset containing the misclassified class values and a training sample dataset with the accuracy score for each training sample.

    Arguments:
    in_raster -- The input raster to be classified.
    in_training_features -- A training sample feature class created in the Training Samples Manager pane.
    in_classifier_definition -- The .ecd output classifier file from any of the train classifier tools. The .ecd file is a JSON file that contains attribute information, statistics, or other information needed for the classifier.
    out_training_feature_class -- The output individual training samples saved as a feature class. The associated attribute table contains an addition field listing the accuracy score.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for the classifier. This raster will be necessary when calculating attributes such as mean or standard deviation. This parameter is optional.

    Results:
    out_misclassified_raster -- Output Misclassified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            in_additional_raster):
        out_misclassified_raster = "#"
        result = arcpy.gp.InspectTrainingSamples_ia(
            in_raster,
            in_training_features,
            in_classifier_definition,
            out_training_feature_class,
            out_misclassified_raster,
            in_additional_raster)
        return _wrapToolRaster(u"InspectTrainingSamples_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_training_features,
        in_classifier_definition,
        out_training_feature_class,
        in_additional_raster)
InspectTrainingSamples.__esri_toolname__ = "InspectTrainingSamples_ia"
InspectTrainingSamples.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::6"
]


def RemoveRasterSegmentTilingArtifacts(
        in_segmented_raster,
        tileSizeX="#",
        tileSizeY="#"):
    """RemoveRasterSegmentTilingArtifacts(in_segmented_raster, {tileSizeX}, {tileSizeY})

    Some regional processes, such as image segmentation, will have inconsistencies near image tile boundaries. This tool corrects segments or objects cut by tile boundaries during the segmentation process performed as a raster function.

    Arguments:
    in_segmented_raster -- Select the segmented raster with the tiling artifacts that you want to remove.
    tileSizeX -- Specify the tile width from Segment Mean Shift. If left blank, the default is 512 pixels.
    tileSizeY -- Specify the tile height from Segment Mean Shift. If left blank, the default is 512 pixels.

    Results:
    out_raster_dataset -- Output Segmented Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_segmented_raster,
            tileSizeX,
            tileSizeY):
        out_raster_dataset = "#"
        result = arcpy.gp.RemoveRasterSegmentTilingArtifacts_ia(
            in_segmented_raster,
            out_raster_dataset,
            tileSizeX,
            tileSizeY)
        return _wrapToolRaster(u"RemoveRasterSegmentTilingArtifacts_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_segmented_raster,
        tileSizeX,
        tileSizeY)
RemoveRasterSegmentTilingArtifacts.__esri_toolname__ = "RemoveRasterSegmentTilingArtifacts_ia"
RemoveRasterSegmentTilingArtifacts.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def SegmentMeanShift(
        in_raster,
        spectral_detail="#",
        spatial_detail="#",
        min_segment_size="#",
        band_indexes="#"):
    """SegmentMeanShift(in_raster, {spectral_detail}, {spatial_detail}, {min_segment_size}, {band_indexes})

    Groups into segments adjacent pixels that have similar spectral characteristics.

    Arguments:
    in_raster -- Select the raster dataset you want to segment. This can be a multispectral or grayscale image.
    spectral_detail -- The level of importance given to the spectral differences of features in your imagery.
    spatial_detail -- The level of importance given to the proximity between features in your imagery.
    min_segment_size -- Merge segments smaller than this size with their best fitting neighbor segment. This is related to the minimum mapping unit for your project.
    band_indexes -- Select the bands you want to use to segment your imagery, separated by a space. If no band indexes are specified, they are chosen by the following criteria:

    Results:
    out_raster_dataset -- Output Raster Dataset"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes):
        out_raster_dataset = "#"
        result = arcpy.gp.SegmentMeanShift_ia(
            in_raster,
            out_raster_dataset,
            spectral_detail,
            spatial_detail,
            min_segment_size,
            band_indexes)
        return _wrapToolRaster(u"SegmentMeanShift_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        spectral_detail,
        spatial_detail,
        min_segment_size,
        band_indexes)
SegmentMeanShift.__esri_toolname__ = "SegmentMeanShift_ia"
SegmentMeanShift.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def TrainIsoClusterClassifier(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster="#",
        max_iterations="#",
        min_samples_per_cluster="#",
        skip_factor="#",
        used_attributes="#",
        max_merge_per_iter="#",
        max_merge_distance="#"):
    """TrainIsoClusterClassifier(in_raster, max_classes, out_classifier_definition, {in_additional_raster}, {max_iterations}, {min_samples_per_cluster}, {skip_factor}, {[used_attributes;used_attributes,...]}, {max_merge_per_iter}, {max_merge_distance})

    Generates an Esri classifier definition file (.ecd) using the Iso Cluster classification definition.

    Arguments:
    in_raster -- The raster dataset to classify.
    max_classes -- Maximum number of desired classes to group pixels or segments. This should be set to be greater than the number of classes in your legend.
    out_classifier_definition -- The output JSON file that contains attribute information, statistics, hyperplane vectors, and other information for the classifier. An .ecd file is created.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for classification. This parameter is optional.
    max_iterations -- The maximum number of iterations the clustering process will run.
    min_samples_per_cluster -- The minimum number of pixels or segments in a valid cluster or class.
    skip_factor -- Number of pixels to skip for a pixel image input. If a segmented image is an input, specify the number of segments to skip.
    used_attributes;used_attributes -- Specifies the attributes to be included in the attribute table associated with the output raster.
    max_merge_per_iter -- The maximum number of cluster merges per iteration. Increasing the number of merges will reduce the number of classes that are created. A lower value will result in more classes.
    max_merge_distance -- The maximum distance between cluster centers in feature space. Increasing the distance will allow more clusters to merge, resulting in fewer classes. A lower value will result in more classes. Values from 0 to 5 tend to give the best results."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance):
        result = arcpy.gp.TrainIsoClusterClassifier_ia(
            in_raster,
            max_classes,
            out_classifier_definition,
            in_additional_raster,
            max_iterations,
            min_samples_per_cluster,
            skip_factor,
            used_attributes,
            max_merge_per_iter,
            max_merge_distance)
        return result
    return Wrapper(
        in_raster,
        max_classes,
        out_classifier_definition,
        in_additional_raster,
        max_iterations,
        min_samples_per_cluster,
        skip_factor,
        used_attributes,
        max_merge_per_iter,
        max_merge_distance)
TrainIsoClusterClassifier.__esri_toolname__ = "TrainIsoClusterClassifier_ia"
TrainIsoClusterClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10"
]


def TrainMaximumLikelihoodClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        used_attributes="#"):
    """TrainMaximumLikelihoodClassifier(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {[used_attributes,...]})

    Generates an Esri classifier definition file (.ecd) using the Maximum Likelihood Classifier (MLC) classification definition.

    Arguments:
    in_raster -- The raster dataset to classify.
    in_training_features -- The training sample file or layer that delineates your training sites.
    out_classifier_definition -- The output JSON file that contains attribute information, statistics, hyperplane vectors, and other information for the classifier. An .ecd file is created.
    in_additional_raster -- Optionally incorporate ancillary raster datasets, such as a segmented image or DEM.
    used_attributes -- Specifies the attributes to be included in the attribute table associated with the output raster."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes):
        result = arcpy.gp.TrainMaximumLikelihoodClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            used_attributes)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        used_attributes)
TrainMaximumLikelihoodClassifier.__esri_toolname__ = "TrainMaximumLikelihoodClassifier_ia"
TrainMaximumLikelihoodClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def TrainRandomTreesClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_num_trees="#",
        max_tree_depth="#",
        max_samples_per_class="#",
        used_attributes="#"):
    """TrainRandomTreesClassifier(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_num_trees}, {max_tree_depth}, {max_samples_per_class}, {[used_attributes;used_attributes,...]})

    Generates an Esri classifier definition file (.ecd) using the Random Trees classification method.

    Arguments:
    in_raster -- The raster dataset to classify.
    in_training_features -- The training sample file or layer that delineates your training sites.
    out_classifier_definition -- A JSON file that contains attribute information, statistics, or other information needed for the classifier. A file with an .ecd extension is created.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for classification. This parameter is optional.
    max_num_trees -- The maximum number of trees in the forest. Increasing the number of trees will lead to higher accuracy rates, although this improvement will level off eventually. The number of trees increases the processing time linearly.
    max_tree_depth -- The maximum depth of each tree in the forest. Depth is another way of saying the number of rules each tree is allowed to create to come to a decision. Trees will not grow any deeper than this setting.
    max_samples_per_class -- The maximum number of samples to use for defining each class.
    used_attributes;used_attributes -- Specifies the attributes to be included in the attribute table associated with the output raster."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes):
        result = arcpy.gp.TrainRandomTreesClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_num_trees,
            max_tree_depth,
            max_samples_per_class,
            used_attributes)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_num_trees,
        max_tree_depth,
        max_samples_per_class,
        used_attributes)
TrainRandomTreesClassifier.__esri_toolname__ = "TrainRandomTreesClassifier_ia"
TrainRandomTreesClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8"
]


def TrainSupportVectorMachineClassifier(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster="#",
        max_samples_per_class="#",
        used_attributes="#"):
    """TrainSupportVectorMachineClassifier(in_raster, in_training_features, out_classifier_definition, {in_additional_raster}, {max_samples_per_class}, {[used_attributes;used_attributes,...]})

    Generates an Esri classifier definition file (.ecd) using the Support Vector Machine (SVM) classification definition.

    Arguments:
    in_raster -- The raster dataset to classify.
    in_training_features -- The training sample file or layer that delineates your training sites.
    out_classifier_definition -- The output JSON file that contains attribute information, statistics, hyperplane vectors, and other information for the classifier. An .ecd file is created.
    in_additional_raster -- Ancillary raster datasets, such as a multispectral image or a DEM, are incorporated to generate attributes and other required information for classification. This parameter is optional.
    max_samples_per_class -- The maximum number of samples to use for defining each class.
    used_attributes;used_attributes -- Specifies the attributes to be included in the attribute table associated with the output raster."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes):
        result = arcpy.gp.TrainSupportVectorMachineClassifier_ia(
            in_raster,
            in_training_features,
            out_classifier_definition,
            in_additional_raster,
            max_samples_per_class,
            used_attributes)
        return result
    return Wrapper(
        in_raster,
        in_training_features,
        out_classifier_definition,
        in_additional_raster,
        max_samples_per_class,
        used_attributes)
TrainSupportVectorMachineClassifier.__esri_toolname__ = "TrainSupportVectorMachineClassifier_ia"
TrainSupportVectorMachineClassifier.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def UpdateAccuracyAssessmentPoints(
        in_class_data,
        in_points,
        out_points,
        target_field="#"):
    """UpdateAccuracyAssessmentPoints(in_class_data, in_points, out_points, {target_field})

    Updates the Target field in the attribute table to compare reference points to the classified image.

    Arguments:
    in_class_data -- The input classification image or other thematic GIS reference data. The input can be a raster or feature class.
    in_points -- The point feature class providing the accuracy assessment points to be updated.
    out_points -- The output point feature class which contains the updated random point field for accuracy assessment purposes.
    target_field -- Specifies whether the input data is a classified image or ground truth data."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_class_data,
            in_points,
            out_points,
            target_field):
        result = arcpy.gp.UpdateAccuracyAssessmentPoints_ia(
            in_class_data,
            in_points,
            out_points,
            target_field)
        return result
    return Wrapper(
        in_class_data,
        in_points,
        out_points,
        target_field)
UpdateAccuracyAssessmentPoints.__esri_toolname__ = "UpdateAccuracyAssessmentPoints_ia"
UpdateAccuracyAssessmentPoints.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4"
]


def CellStatistics(
        in_rasters_or_constants,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multiband="#"):
    """CellStatistics([in_raster_or_constant,...], {statistics_type}, {ignore_nodata}, {process_as_multiband})

    Calculates a per-cell statistic from multiple rasters.

    Arguments:
    in_raster_or_constant -- A list of input rasters for which a statistic will be calculated for each cell within the Analysis window.
    statistics_type -- Statistic type to be calculated.
    ignore_nodata -- Denotes whether NoData values are ignored by the statistic calculation.
    process_as_multiband -- Determines how multiband input rasters bands are processed.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_rasters_or_constants,
            statistics_type,
            ignore_nodata,
            process_as_multiband):
        statisticsTypes = {
            "MAJORITY": "Majority",
            "MAXIMUM": "Max",
            "MEAN": "Mean",
            "MEDIAN": "Med",
            "MINIMUM": "Min",
            "MINORITY": "Minority",
            "RANGE": "Range",
            "STD": "Std",
            "SUM": "Sum",
            "VARIETY": "Variety"
        }
        if Utils.useDefaultArgumentValue(statistics_type):
            statistics_type = "MEAN"
        if not statistics_type in statisticsTypes:
            raise arcpy.ExecuteError("ERROR 000864: Overlay statistic: The input is not within the defined domain.\nERROR 000800: The value is not a member of MEAN | MAJORITY | MAXIMUM | MEDIAN | MINIMUM | MINORITY | RANGE | STD | SUM | VARIETY.\n")
        function = statisticsTypes[statistics_type]
        if Utils.useDefaultArgumentValue(ignore_nodata):
            ignore_nodata = "DATA"
        if ignore_nodata not in ["DATA", "NODATA"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter ignore_nodata not within domain.\n")
        if Utils.useDefaultArgumentValue(process_as_multiband):
            process_as_multiband = "SINGLE_BAND"
        if process_as_multiband not in ["SINGLE_BAND", "MULTI_BAND"]:
            raise arcpy.ExecuteError("ERROR 000622: Failed to execute (CellStatistics). Parameters are not valid.\nERROR 000621: Input to parameter process_as_multiband not within domain.\n")
        if Utils.argumentValueEqualsString(ignore_nodata, "DATA"):
            function += "ContinueOnNoData"
        return _wrapLocalFunctionRaster(u"CellStatistics_sa",
            [function] + Utils.flattenLists(in_rasters_or_constants), {"flattenBands" : process_as_multiband.upper() == "SINGLE_BAND"})
    return Wrapper(
        in_rasters_or_constants,
        statistics_type,
        ignore_nodata,
        process_as_multiband)
CellStatistics.__esri_toolname__ = "CellStatistics_ia"
CellStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def FocalStatistics(
        in_raster,
        neighborhood="#",
        statistics_type="#",
        ignore_nodata="#",
        percentile_value="#"):
    """FocalStatistics(in_raster, {neighborhood}, {statistics_type}, {ignore_nodata}, {percentile_value})

    Calculates for each input cell location a statistic of the values within a specified neighborhood around it.

    Arguments:
    in_raster -- The raster on which the focal statistics will be calculated.
    neighborhood -- The Neighborhood class dictates the shape of the area around each cell used to calculate the statistic.
    statistics_type -- Specifies the statistic type to be calculated.
    ignore_nodata -- Specifies whether NoData values will be ignored by the statistic calculation.
    percentile_value -- The percentile to calculate. The default is 90, for the 90th percentile.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            neighborhood,
            statistics_type,
            ignore_nodata,
            percentile_value):
        neighborhood = Utils.compoundParameterToString(neighborhood, ParameterClasses._Neighborhood)
        out_raster = "#"
        result = arcpy.gp.FocalStatistics_ia(
            in_raster,
            out_raster,
            neighborhood,
            statistics_type,
            ignore_nodata,
            percentile_value)
        return _wrapToolRaster(u"FocalStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        neighborhood,
        statistics_type,
        ignore_nodata,
        percentile_value)
FocalStatistics.__esri_toolname__ = "FocalStatistics_ia"
FocalStatistics.__esri_toolinfo__ = [
    "::::1",
    "Python::NbrAnnulus|NbrCircle|NbrIrregular|NbrRectangle|NbrWedge|NbrWeight::",
    "::::4",
    "::::5",
    "::::6"
]


def ZonalStatistics(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type="#",
        ignore_nodata="#",
        process_as_multidimensional="#"):
    """ZonalStatistics(in_zone_data, zone_field, in_value_raster, {statistics_type}, {ignore_nodata}, {process_as_multidimensional})

    Calculates statistics on values of a raster within the zones of another dataset.

    Arguments:
    in_zone_data -- Dataset that defines the zones.
    zone_field -- Field that holds the values that define each zone.
    in_value_raster -- Raster that contains the values on which to calculate a statistic.
    statistics_type -- Statistic type to be calculated.
    ignore_nodata -- Denotes whether NoData values in the Value input will influence the results of the zone that they fall within.
    process_as_multidimensional -- Determines how the input value raster will be processed if it is multidimensional.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_zone_data,
            zone_field,
            in_value_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional):
        out_raster = "#"
        result = arcpy.gp.ZonalStatistics_ia(
            in_zone_data,
            zone_field,
            in_value_raster,
            out_raster,
            statistics_type,
            ignore_nodata,
            process_as_multidimensional)
        return _wrapToolRaster(u"ZonalStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_zone_data,
        zone_field,
        in_value_raster,
        statistics_type,
        ignore_nodata,
        process_as_multidimensional)
ZonalStatistics.__esri_toolname__ = "ZonalStatistics_ia"
ZonalStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::5",
    "::::6",
    "::::7"
]


def VideoMultiplexer(
        in_video_file,
        metadata_file,
        out_video_file,
        metadata_mapping_file="#",
        timeshift_file="#",
        elevation_layer="#"):
    """VideoMultiplexer(in_video_file, metadata_file, out_video_file, {metadata_mapping_file}, {timeshift_file}, {elevation_layer})

    Creates a video file that combines an archived video stream file and an associated metadata file synchronized by a time stamp.

    Arguments:
    in_video_file -- The input video file that will be converted to a FMV-compliant video file.
    metadata_file -- A comma-separated values (CSV) file containing metadata about the video frames for specific times.
    out_video_file -- The name of the output video file, including the file extension.
    metadata_mapping_file -- A CSV file that contains 5 columns and 87 rows and is based on the FMV_Multiplexer_Field_Mapping_Template.csv template file obtained from C:\Program Files\ArcGIS\Pro\Resources\FullMotionVideo.
    timeshift_file -- A file containing defined time shift intervals.
    elevation_layer -- The source of the elevation needed for calculating the video frame corner coordinates. The source can be a layer, image service, or an average ground elevation or ocean depth. The average elevation value needs to include the units of measurement such as meters or feet or other measure of length."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video_file,
            metadata_file,
            out_video_file,
            metadata_mapping_file,
            timeshift_file,
            elevation_layer):
        result = arcpy.gp.VideoMultiplexer_ia(
            in_video_file,
            metadata_file,
            out_video_file,
            metadata_mapping_file,
            timeshift_file,
            elevation_layer)
        return result
    return Wrapper(
        in_video_file,
        metadata_file,
        out_video_file,
        metadata_mapping_file,
        timeshift_file,
        elevation_layer)
VideoMultiplexer.__esri_toolname__ = "VideoMultiplexer_ia"
VideoMultiplexer.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def ClassifyPixelsUsingDeepLearning(
        in_raster,
        in_model_definition,
        arguments="#",
        processing_mode="#"):
    """ClassifyPixelsUsingDeepLearning(in_raster, in_model_definition, {[arguments,...]}, {processing_mode})

    Runs a trained deep learning model on an input raster to produce a classified raster, with each valid pixel having an assigned class label.

    Arguments:
    in_raster -- The input raster dataset to classify. The input can be a single raster or multiple rasters in a mosaic dataset, an image service, or a folder of images.
    in_model_definition -- The in_model_definition parameter value can be an Esri model definition JSON file (.emd), a JSON string, or a deep learning model package (.dlpk). A JSON string is useful when this tool is used on the server so you can paste the JSON string, rather than upload the .emd file. The .dlpk file must be stored locally.
    arguments -- The function arguments are defined in the Python raster function class. This is where you list additional deep learning parameters and arguments for experiments and refinement, such as a confidence threshold for adjusting the sensitivity. The names of the arguments are populated by the tool from reading the Python module.
    processing_mode -- Specifies how 
all raster items in a mosaic dataset or an image service will be processed. This parameter is applied when the input raster is a mosaic dataset or an image service.

    Results:
    out_classified_raster -- Output Classified Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_model_definition,
            arguments,
            processing_mode):
        out_classified_raster = "#"
        result = arcpy.gp.ClassifyPixelsUsingDeepLearning_ia(
            in_raster,
            out_classified_raster,
            in_model_definition,
            arguments,
            processing_mode)
        return _wrapToolRaster(u"ClassifyPixelsUsingDeepLearning_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_model_definition,
        arguments,
        processing_mode)
ClassifyPixelsUsingDeepLearning.__esri_toolname__ = "ClassifyPixelsUsingDeepLearning_ia"
ClassifyPixelsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5"
]


def DetectObjectsUsingDeepLearning(
        in_raster,
        out_detected_objects,
        in_model_definition,
        arguments="#",
        run_nms="#",
        confidence_score_field="#",
        class_value_field="#",
        max_overlap_ratio="#",
        processing_mode="#"):
    """DetectObjectsUsingDeepLearning(in_raster, out_detected_objects, in_model_definition, {[arguments,...]}, {run_nms}, {confidence_score_field}, {class_value_field}, {max_overlap_ratio}, {processing_mode})

    Runs a trained deep learning model on an input raster to produce a feature class containing the objects it finds. The features can be bounding boxes or polygons around the objects found, or points at the centers of the objects.

    Arguments:
    in_raster -- Input image used to detect objects. The input can be a single raster or multiple rasters in a mosaic dataset, image service, or folder of images.
    out_detected_objects -- The output feature class that contains geometries circling the object or objects detected in the input image.
    in_model_definition -- The in_model_definition parameter value can be an Esri model definition JSON file (.emd), a JSON string, or a deep learning model package (.dlpk). A JSON string is useful when this tool is used on the server so you can paste the JSON string, rather than upload the .emd file. The .dlpk file must be stored locally.
    arguments -- The function arguments are defined in the Python raster function class. This is where you list additional deep learning parameters and arguments for experiments and refinement, such as a confidence threshold for adjusting the sensitivity. The names of the arguments are populated by the tool from reading the Python module.
    run_nms -- Performs non-maximum suppression, where duplicate objects are identified and the duplicate feature with a lower confidence value is removed.
    confidence_score_field -- The name of the field in the feature class that contains the confidence scores as output by the object detection method.
    class_value_field -- The name of the class value field in the input feature class. If not specified, the tool will use the standard class value fields  Classvalue and Value. If these fields do not exist, all features will be treated as the same object class.
    max_overlap_ratio -- The maximum overlap ratio for two overlapping features, which is defined as the ratio of intersection area over union area. The default is 0.
    processing_mode -- Specifies how 
all raster items in a mosaic dataset or an image service will be processed. This parameter is applied when the input raster is a mosaic dataset or an image service."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_detected_objects,
            in_model_definition,
            arguments,
            run_nms,
            confidence_score_field,
            class_value_field,
            max_overlap_ratio,
            processing_mode):
        result = arcpy.gp.DetectObjectsUsingDeepLearning_ia(
            in_raster,
            out_detected_objects,
            in_model_definition,
            arguments,
            run_nms,
            confidence_score_field,
            class_value_field,
            max_overlap_ratio,
            processing_mode)
        return result
    return Wrapper(
        in_raster,
        out_detected_objects,
        in_model_definition,
        arguments,
        run_nms,
        confidence_score_field,
        class_value_field,
        max_overlap_ratio,
        processing_mode)
DetectObjectsUsingDeepLearning.__esri_toolname__ = "DetectObjectsUsingDeepLearning_ia"
DetectObjectsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def NonMaximumSuppression(
        in_featureclass,
        confidence_score_field,
        out_featureclass,
        class_value_field="#",
        max_overlap_ratio="#"):
    """NonMaximumSuppression(in_featureclass, confidence_score_field, out_featureclass, {class_value_field}, {max_overlap_ratio})

    Identifies duplicate features from the output of the Detect Objects Using Deep Learning tool as a postprocessing step and creates a new output with no duplicate features. The Detect Objects Using Deep Learning tool can return more than one bounding box or polygon for the same object, especially as a tiling side effect. If two features overlap more than a given maximum ratio, the feature with the lower confidence value will be removed.

    Arguments:
    in_featureclass -- The input feature class or feature layer containing overlapping or duplicate features.
    confidence_score_field -- The field in the feature class that contains the confidence scores as output by the object detection method.
    out_featureclass -- The output feature class with the duplicate features removed.
    class_value_field -- The class value field in the input feature class. If not specified, the tool will use the standard class value fields  Classvalue and Value. If these fields do not exist, all features will be treated as the same object class.
    max_overlap_ratio -- The maximum overlap ratio for two overlapping features. This is defined as the ratio of intersection area over union area. The default is 0."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_featureclass,
            confidence_score_field,
            out_featureclass,
            class_value_field,
            max_overlap_ratio):
        result = arcpy.gp.NonMaximumSuppression_ia(
            in_featureclass,
            confidence_score_field,
            out_featureclass,
            class_value_field,
            max_overlap_ratio)
        return result
    return Wrapper(
        in_featureclass,
        confidence_score_field,
        out_featureclass,
        class_value_field,
        max_overlap_ratio)
NonMaximumSuppression.__esri_toolname__ = "NonMaximumSuppression_ia"
NonMaximumSuppression.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5"
]


def VideoMetadataToFeatureClass(
        in_video,
        csv_file="#",
        flightpath="#",
        flightpath_type="#",
        imagepath="#",
        imagepath_type="#",
        footprint="#",
        start_time="#",
        stop_time="#",
        min_distance="#",
        min_time="#"):
    """VideoMetadataToFeatureClass(in_video, {csv_file}, {flightpath}, {flightpath_type}, {imagepath}, {imagepath_type}, {footprint}, {start_time}, {stop_time}, {min_distance}, {min_time})

    Extracts the platform, frame center, frame outline, and attributes metadata from an FMV-compliant video. The output geometry and attributes are saved as feature classes.

    Arguments:
    in_video -- The FMV-compliant input video file containing essential metadata for each frame of the video data. The supported video file types include PS, TS, MPG, MPEG, MP2, MPG2, MPEG2, MP4, MPG4, MPEG4, H264, VOB, and M2TS.
    csv_file -- A comma-separated values (CSV) file containing metadata about the video frames for specific times.
    flightpath -- The feature class containing the sensor's flight path information.
    flightpath_type -- Specifies the feature class type for the flight path.
    imagepath -- The output feature class containing the image path information.
    imagepath_type -- Specifies the feature class type for the image path.  If you're using a point output, the center of each video frame image will appear on the map.
    footprint -- The output feature class containing the video image footprint information.
    start_time -- The metadata recording start time from the beginning of the video. The input format is d.hh:mm:ss, and the default start time is 0.00:00:00. Metadata time stamps are not used in this field; the time of the video file is used.
    stop_time -- The metadata recording end time. The input format is d.hh:mm:ss. If  not set, the value will default to the end of the video. Metadata time stamps are not used in this field.
    min_distance -- The distance between the features in sequential video frames. If left blank, every metadata feature will be extracted and added to the feature class.
    min_time -- The time interval between the features in sequential video frames. If left blank, every metadata feature will be extracted and added to the feature class."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video,
            csv_file,
            flightpath,
            flightpath_type,
            imagepath,
            imagepath_type,
            footprint,
            start_time,
            stop_time,
            min_distance,
            min_time):
        result = arcpy.gp.VideoMetadataToFeatureClass_ia(
            in_video,
            csv_file,
            flightpath,
            flightpath_type,
            imagepath,
            imagepath_type,
            footprint,
            start_time,
            stop_time,
            min_distance,
            min_time)
        return result
    return Wrapper(
        in_video,
        csv_file,
        flightpath,
        flightpath_type,
        imagepath,
        imagepath_type,
        footprint,
        start_time,
        stop_time,
        min_distance,
        min_time)
VideoMetadataToFeatureClass.__esri_toolname__ = "VideoMetadataToFeatureClass_ia"
VideoMetadataToFeatureClass.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def ExtractVideoFramesToImages(
        in_video,
        out_folder,
        image_type,
        image_overlap="#",
        require_fresh_metadata="#",
        min_time="#"):
    """ExtractVideoFramesToImages(in_video, out_folder, image_type, {image_overlap}, {require_fresh_metadata}, {min_time})

    Extracts video frame images and associated metadata from a FMV-compliant video stream.  The extracted images can be added to a mosaic dataset or other tools and functions for further analysis.

    Arguments:
    in_video -- The input video file in any of the supported video file types, including  PS, TS, MPG, MPEG, MP2, MPG2, MPEG2, MP4, MPG4, MPEG4, H264, VOB, and M2TS.
    out_folder -- The 
file directory where the output images and metadata will be saved.
    image_type -- The output image format.
    image_overlap -- The maximum overlap percentage between two images. If the overlap between a candidate image and the last image written to disk is greater than this value, the candidate image will be ignored. The default percentage is 100%, which writes all images to disk.
    require_fresh_metadata -- Specifies whether  video frames with associated metadata will be extracted and saved.
    min_time -- The minimum time interval between video frames to be saved. If this is not specified, all video frames will be saved as images."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_video,
            out_folder,
            image_type,
            image_overlap,
            require_fresh_metadata,
            min_time):
        result = arcpy.gp.ExtractVideoFramesToImages_ia(
            in_video,
            out_folder,
            image_type,
            image_overlap,
            require_fresh_metadata,
            min_time)
        return result
    return Wrapper(
        in_video,
        out_folder,
        image_type,
        image_overlap,
        require_fresh_metadata,
        min_time)
ExtractVideoFramesToImages.__esri_toolname__ = "ExtractVideoFramesToImages_ia"
ExtractVideoFramesToImages.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def AggregateMultidimensionalRaster(
        in_multidimensional_raster,
        dimension,
        aggregation_method="#",
        variables="#",
        aggregation_def="#",
        interval_keyword="#",
        interval_value="#",
        interval_unit="#",
        interval_ranges="#",
        aggregation_function="#",
        ignore_nodata="#"):
    """AggregateMultidimensionalRaster(in_multidimensional_raster, dimension, {aggregation_method}, {[variables,...]}, {aggregation_def}, {interval_keyword}, {interval_value}, {interval_unit}, {[interval_ranges,...]}, {aggregation_function}, {ignore_nodata})

    Generates a multidimensional raster dataset by aggregating existing multidimensional raster variables along a dimension.

    Arguments:
    in_multidimensional_raster -- The input multidimensional raster dataset.
    dimension -- The aggregation dimension. This is the dimension along which the variables will be aggregated.
    aggregation_method -- Specifies the mathematical method that will be used to combine the aggregated slices in an interval.
    variables -- The variable or variables that will be aggregated along the given dimension. If no variable is specified, all variables with the selected dimension will be aggregated.
    aggregation_def -- Specifies the dimension interval for which the data will be aggregated.
    interval_keyword -- Specifies the keyword interval that will be used when aggregating along the dimension. This parameter is required when the aggregation_def parameter is set to INTERVAL_KEYWORD, and the aggregation must be across time.
    interval_value -- The size of the interval that will be used for the aggregation. This parameter is required when the aggregation_def parameter is set to INTERVAL_VALUE.
    interval_unit -- The unit that will be used for the interval value. This parameter is required when the dimension parameter is set to a time field and the aggregation_def parameter is set to INTERVAL_VALUE.
    interval_ranges -- Interval ranges specified in a value table will be used to aggregate groups of values. The value table consists of pairs of minimum and maximum range values, with data type Double or Date.
    aggregation_function -- A custom raster function that will be used to compute the pixel values of the aggregated rasters. The input is a raster function JSON object or an .rft.xml file created from a function chain or a custom Python raster function.
    ignore_nodata -- Specifies whether NoData values are ignored in the analysis.

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            dimension,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata):
        out_multidimensional_raster = "#"
        result = arcpy.gp.AggregateMultidimensionalRaster_ia(
            in_multidimensional_raster,
            dimension,
            out_multidimensional_raster,
            aggregation_method,
            variables,
            aggregation_def,
            interval_keyword,
            interval_value,
            interval_unit,
            interval_ranges,
            aggregation_function,
            ignore_nodata)
        return _wrapToolRaster(u"AggregateMultidimensionalRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        dimension,
        aggregation_method,
        variables,
        aggregation_def,
        interval_keyword,
        interval_value,
        interval_unit,
        interval_ranges,
        aggregation_function,
        ignore_nodata)
AggregateMultidimensionalRaster.__esri_toolname__ = "AggregateMultidimensionalRaster_ia"
AggregateMultidimensionalRaster.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11",
    "::::12"
]


def GenerateMultidimensionalAnomaly(
        in_multidimensional_raster,
        variables="#",
        method="#",
        calculation_interval="#",
        ignore_nodata="#"):
    """GenerateMultidimensionalAnomaly(in_multidimensional_raster, {[variables,...]}, {method}, {calculation_interval}, {ignore_nodata})

    Computes the anomaly for each slice in a multidimensional raster to generate a multidimensional raster.

    Arguments:
    in_multidimensional_raster -- The input multidimensional raster dataset.
    variables -- The variable or variables for which anomalies will be calculated. If no variable is specified, all variables with a time dimension will be analyzed.
    method -- Specifies the method that will be used to calculate the anomaly.
    calculation_interval -- Specifies the temporal interval that will be used to calculate the mean.
    ignore_nodata -- Specifies whether NoData values are ignored in the analysis.

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata):
        out_multidimensional_raster = "#"
        result = arcpy.gp.GenerateMultidimensionalAnomaly_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            variables,
            method,
            calculation_interval,
            ignore_nodata)
        return _wrapToolRaster(u"GenerateMultidimensionalAnomaly_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        variables,
        method,
        calculation_interval,
        ignore_nodata)
GenerateMultidimensionalAnomaly.__esri_toolname__ = "GenerateMultidimensionalAnomaly_ia"
GenerateMultidimensionalAnomaly.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6"
]


def GenerateTrendRaster(
        in_multidimensional_raster,
        dimension,
        variables="#",
        line_type="#",
        frequency="#",
        ignore_nodata="#"):
    """GenerateTrendRaster(in_multidimensional_raster, dimension, {[variables,...]}, {line_type}, {frequency}, {ignore_nodata})

    Estimates the trend for each pixel along a dimension for one or more variables in a multidimensional raster.

    Arguments:
    in_multidimensional_raster -- The input multidimensional raster dataset.
    dimension -- The dimension along which a trend will be extracted for the variable or variables selected in the analysis.
    variables -- The variable or variables for which trends will be calculated. If no variable is specified, the first variable in the multidimensional raster will be analyzed.
    line_type -- Specifies the type of line to be used to fit to the pixel values along a dimension.
    frequency -- If the line_type parameter is HARMONIC,  the default value is 1 ,or one harmonic cycle per year.
    ignore_nodata -- Specifies whether NoData values are ignored in the analysis.

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            dimension,
            variables,
            line_type,
            frequency,
            ignore_nodata):
        out_multidimensional_raster = "#"
        result = arcpy.gp.GenerateTrendRaster_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            dimension,
            variables,
            line_type,
            frequency,
            ignore_nodata)
        return _wrapToolRaster(u"GenerateTrendRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        dimension,
        variables,
        line_type,
        frequency,
        ignore_nodata)
GenerateTrendRaster.__esri_toolname__ = "GenerateTrendRaster_ia"
GenerateTrendRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def FindArgumentStatistics(
        in_raster,
        dimension="#",
        dimension_def="#",
        interval_keyword="#",
        variables="#",
        statistics_type="#",
        min="#",
        max="#",
        multiple_occurrence="#",
        ignore_nodata="#"):
    """FindArgumentStatistics(in_raster, {dimension}, {dimension_def}, {interval_keyword}, {[variables,...]}, {statistics_type}, {min}, {max}, {multiple_occurrence}, {ignore_nodata})

    Extracts the dimension value  or band index at which a given statistic is attained for each pixel in a multidimensional or multiband raster.

    Arguments:
    in_raster -- The input multidimensional or multiband raster to be analyzed.
    dimension -- The 
dimension from which the statistic will be extracted. If the input raster is not a multidimensional raster, this parameter is not required.
    dimension_def -- Specifies how the statistic will be extracted from the dimension.
    interval_keyword -- The unit of time for which the statistic will be extracted.
    variables -- The variable or variables 
to be analyzed. If the input raster is not multidimensional, the pixel values of the multiband raster are considered the variable. If the input raster is multidimensional and no variable is specified, all variables with the selected dimension will be analyzed.
    statistics_type -- Specifies the statistic to extract from the variable or variables along the given dimension.
    min -- The minimum variable value to be used to extract the duration.
    max -- The maximum variable value to be used to extract the duration.
    multiple_occurrence -- The pixel value to use to indicate that a given argument statistic was reached more than once in the input raster dataset. If not specified, the pixel value will be the value of the dimension the first time the argument statistic is reached.
    ignore_nodata -- Specifies whether NoData values are ignored in the analysis.

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            dimension,
            dimension_def,
            interval_keyword,
            variables,
            statistics_type,
            min,
            max,
            multiple_occurrence,
            ignore_nodata):
        out_raster = "#"
        result = arcpy.gp.FindArgumentStatistics_ia(
            in_raster,
            out_raster,
            dimension,
            dimension_def,
            interval_keyword,
            variables,
            statistics_type,
            min,
            max,
            multiple_occurrence,
            ignore_nodata)
        return _wrapToolRaster(u"FindArgumentStatistics_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        dimension,
        dimension_def,
        interval_keyword,
        variables,
        statistics_type,
        min,
        max,
        multiple_occurrence,
        ignore_nodata)
FindArgumentStatistics.__esri_toolname__ = "FindArgumentStatistics_ia"
FindArgumentStatistics.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]


def PredictUsingTrendRaster(
        in_multidimensional_raster,
        variables="#",
        dimension_def="#",
        dimension_values="#",
        start="#",
        end="#",
        interval_value="#",
        interval_unit="#"):
    """PredictUsingTrendRaster(in_multidimensional_raster, {[variables,...]}, {dimension_def}, {dimension_values}, {start}, {end}, {interval_value}, {interval_unit})

    Computes a forecasted multidimensional raster using the output trend raster from the Generate Trend Raster tool.

    Arguments:
    in_multidimensional_raster -- The input multidimensional trend raster from the Generate Trend Raster tool.
    variables -- The variable or variables 
that will be predicted in the analysis. If no variables are specified, all variables will be used.
    dimension_def -- Specifies the method used to provide prediction dimension values.
    dimension_values -- The dimension value or values to be used in the prediction.
    start -- The start date, height, or depth of the dimension interval to be used in the prediction.
    end -- The end date, height, or depth of the dimension interval to be used in the prediction.
    interval_value -- The number of steps between two dimension values to be included in the prediction. 
The default value is 1.
    interval_unit -- Specifies the unit that will be used for the value interval. This parameter only applies when the dimension of analysis is a time dimension.

    Results:
    out_multidimensional_raster -- Output Multidimensional Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_multidimensional_raster,
            variables,
            dimension_def,
            dimension_values,
            start,
            end,
            interval_value,
            interval_unit):
        out_multidimensional_raster = "#"
        result = arcpy.gp.PredictUsingTrendRaster_ia(
            in_multidimensional_raster,
            out_multidimensional_raster,
            variables,
            dimension_def,
            dimension_values,
            start,
            end,
            interval_value,
            interval_unit)
        return _wrapToolRaster(u"PredictUsingTrendRaster_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_multidimensional_raster,
        variables,
        dimension_def,
        dimension_values,
        start,
        end,
        interval_value,
        interval_unit)
PredictUsingTrendRaster.__esri_toolname__ = "PredictUsingTrendRaster_ia"
PredictUsingTrendRaster.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9"
]


def LinearSpectralUnmixing(
        in_raster,
        in_spectral_profile_file,
        value_option="#"):
    """LinearSpectralUnmixing(in_raster, in_spectral_profile_file, {[value_option,...]})

    Performs subpixel classification and calculates the fractional abundance  of   different land cover types for        individual pixels.

    Arguments:
    in_raster -- The 
input raster dataset.
    in_spectral_profile_file -- The  spectral information for the different land cover classes.
    value_option -- Specifies how the output pixel values will be defined.

    Results:
    out_raster -- Output Raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def Wrapper(
            in_raster,
            in_spectral_profile_file,
            value_option):
        out_raster = "#"
        result = arcpy.gp.LinearSpectralUnmixing_ia(
            in_raster,
            out_raster,
            in_spectral_profile_file,
            value_option)
        return _wrapToolRaster(u"LinearSpectralUnmixing_sa", unicode(result.getOutput(0)))
    return Wrapper(
        in_raster,
        in_spectral_profile_file,
        value_option)
LinearSpectralUnmixing.__esri_toolname__ = "LinearSpectralUnmixing_ia"
LinearSpectralUnmixing.__esri_toolinfo__ = [
    "::::1",
    "::::3",
    "::::4"
]


def ClassifyObjectsUsingDeepLearning(
        in_raster,
        out_feature_class,
        in_model_definition,
        in_features="#",
        class_label_field="#",
        processing_mode="#",
        model_arguments="#"):
    """ClassifyObjectsUsingDeepLearning(in_raster, out_feature_class, in_model_definition, {in_features}, {class_label_field}, {processing_mode}, {[model_arguments,...]})

    Runs a trained deep learning model on an input raster and  an optional feature class to produce a feature class or table in which each input object has a class label assigned.

    Arguments:
    in_raster -- The input raster dataset to classify. The input can be a single raster or multiple rasters in a mosaic dataset, an image service, or a folder of images.
    out_feature_class -- The output feature class that contains geometries surrounding the objects from the input feature class, as well as a field to store the classification label.
    in_model_definition -- The in_model_definition parameter value can be an Esri model definition JSON file (.emd), a JSON string, or a deep learning model package (.dlpk). A JSON string is useful when this tool is used on the server so you can paste the JSON string, rather than upload the .emd file. The .dlpk file must be stored locally.
    in_features -- The point, line, or polygon input feature class that identifies the location of each object to be classified and labelled. Each row in the input feature class represents a single object.
    class_label_field -- The name of the field that will contain the classification label in the output feature class.
    processing_mode -- Specifies how 
all raster items in a mosaic dataset or an image service will be processed. This parameter is applied when the input raster is a mosaic dataset or an image service.
    model_arguments -- The function arguments are defined in the Python raster function class. This is where you list additional deep learning parameters and arguments for experiments and refinement, such as a confidence threshold for adjusting the sensitivity. The names of the arguments are populated by the tool from reading the Python module."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_raster,
            out_feature_class,
            in_model_definition,
            in_features,
            class_label_field,
            processing_mode,
            model_arguments):
        result = arcpy.gp.ClassifyObjectsUsingDeepLearning_ia(
            in_raster,
            out_feature_class,
            in_model_definition,
            in_features,
            class_label_field,
            processing_mode,
            model_arguments)
        return result
    return Wrapper(
        in_raster,
        out_feature_class,
        in_model_definition,
        in_features,
        class_label_field,
        processing_mode,
        model_arguments)
ClassifyObjectsUsingDeepLearning.__esri_toolname__ = "ClassifyObjectsUsingDeepLearning_ia"
ClassifyObjectsUsingDeepLearning.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7"
]


def TrainDeepLearningModel(
        in_folder,
        out_folder,
        max_epochs="#",
        model_type="#",
        batch_size="#",
        arguments="#",
        learning_rate="#",
        backbone_model="#",
        pretrained_model="#",
        validation_percentage="#",
        stop_training="#"):
    """TrainDeepLearningModel(in_folder, out_folder, {max_epochs}, {model_type}, {batch_size}, {[arguments,...]}, {learning_rate}, {backbone_model}, {pretrained_model}, {validation_percentage}, {stop_training})

    Trains a deep learning model using the output from the Export Training Data For Deep Learning tool.

    Arguments:
    in_folder -- The folder containing the image chips, labels, and statistics required to train the model. This is the output from the Export Training Data For Deep Learning tool.
    out_folder -- The output folder location that will store the trained model.
    max_epochs -- The maximum number of epochs for which the model should be trained.
A maximum epoch of one means the dataset will be passed forward and backward through the neural network one time. The default value is 20.
    model_type -- Specifies the 
model type to use for training the deep learning model.
    batch_size -- The number of training samples to be processed for training at one time.     The default value is 2.
    arguments -- The function arguments are defined in the Python raster function class. This is where you list additional deep learning parameters and arguments for experiments and refinement, such as a confidence threshold for adjusting the sensitivity. The names of the arguments are populated by the tool from reading the Python module.
    learning_rate -- The rate at which old information will be overwritten with newly acquired information throughout the training process.   If nothing is specified, the optimal learning rate will be extracted from the learning curve during the training process.
    backbone_model -- Specifies the preconfigured neural network to be used as an architecture for training the new model. This method is known as Transfer Learning. The default is ResNet34.
    pretrained_model -- The pretrained model to be used for fine tune training the new model. The input is an Esri Model Definition file (.emd).
    validation_percentage -- The percentage of training samples that will be used for validating the model. The default value is 10.
    stop_training -- Specifies whether early stopping will be implemented."""
    @Utils.StateSwapper(Utils.StateSwapper.NoSingleRasterResult)
    def Wrapper(
            in_folder,
            out_folder,
            max_epochs,
            model_type,
            batch_size,
            arguments,
            learning_rate,
            backbone_model,
            pretrained_model,
            validation_percentage,
            stop_training):
        result = arcpy.gp.TrainDeepLearningModel_ia(
            in_folder,
            out_folder,
            max_epochs,
            model_type,
            batch_size,
            arguments,
            learning_rate,
            backbone_model,
            pretrained_model,
            validation_percentage,
            stop_training)
        return result
    return Wrapper(
        in_folder,
        out_folder,
        max_epochs,
        model_type,
        batch_size,
        arguments,
        learning_rate,
        backbone_model,
        pretrained_model,
        validation_percentage,
        stop_training)
TrainDeepLearningModel.__esri_toolname__ = "TrainDeepLearningModel_ia"
TrainDeepLearningModel.__esri_toolinfo__ = [
    "::::1",
    "::::2",
    "::::3",
    "::::4",
    "::::5",
    "::::6",
    "::::7",
    "::::8",
    "::::9",
    "::::10",
    "::::11"
]

def ApplyEnvironment(
        in_raster):
    """ApplyEnvironment(in_raster)

    Creates a copy of in_raster with environment settings applied.

    Arguments:
    in_raster -- The input that will be copied.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster):
        return _wrapLocalFunctionRaster(u"ApplyEnvironment",
            ["Copy", in_raster])
    return wrapper(
        in_raster)

def FloatDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloatDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a true floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloatDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)

def FloorDivide(
        in_raster_or_constant1,
        in_raster_or_constant2):
    """FloorDivide(in_raster_or_constant1, in_raster_or_constant2)

    Divides the values of two rasters on a cell-by-cell basis. The result will
    be a floored floating point division.

    Arguments:
    in_raster_or_constant1 -- The input whose values will be divided by the second input.
    in_raster_or_constant2 -- The input whose values the first input are to be divided by.

    Results:
    out_raster -- Output raster"""
    @Utils.StateSwapper(Utils.StateSwapper.SingleRasterResult)
    def wrapper(
            in_raster_or_constant1,
            in_raster_or_constant2):
        return _wrapLocalFunctionRaster(u"Divide_sa",
            ["FloorDivide", in_raster_or_constant1, in_raster_or_constant2])
    return wrapper(
        in_raster_or_constant1,
        in_raster_or_constant2)